PROGRAM PALX (SOURCEFILE, LISTFILE, OBJECTFILE, OUTPUT);




(*

     PPPPPPPPPP        AAAAAAAA      LL              XX          XX
     PPPPPPPPPPP      AAAAAAAAAA     LL              XX          XX
     PP        PP    AA        AA    LL               XX        XX
     PP        PP    AA        AA    LL                XX      XX
     PP        PP    AA        AA    LL                 XX    XX
     PP        PP    AA        AA    LL                  XX  XX
     PPPPPPPPPPP     AA        AA    LL                    XX
     PPPPPPPPPP      AA        AA    LL                    XX
     PP              AAAAAAAAAAAA    LL                  XX  XX
     PP              AAAAAAAAAAAA    LL                 XX    XX
     PP              AA        AA    LL                XX      XX
     PP              AA        AA    LL               XX        XX
     PP              AA        AA    LLLLLLLLLLLL     XX        XX
     PP              AA        AA    LLLLLLLLLLLL     XX        XX

                         BOB ARMSTRONG
                          AUGUST 1981

*)








(*
	***** L A B E L S *****

      THIS  PROGRAM  CONTAINS  ONLY ONE LABEL, AND THAT IS LOCATED AT
   THE  VERY  END  OF  THE MAIN PROGRAM. ITS SOLE USE IS TO PROVIDE A
   GLOBAL  ERROR EXIT, SINCE PASCAL PROVIDES NO BETTER WAY TO GET OUT
   OF A PROGRAM....
*)
LABEL
	9999;	(* THIS IS ON THE LAST END OF THE ENTIRE PROGRAM... *)








(*
	***** C O N S T A N T   D E C L A R A T I O N S *****
*)
CONST




(*
      THESE CONSTANTS DETERMINE EASILY CHANGEABLE PARAMETERS, SUCH AS
   THE  MAXIMUM  NUMBER  OF SYMBOLS, THE LENGTH OF SOURCE LINES, ETC.
   THIS  PROGRAM  MAY BE RE-COMPILED WITH ANY OF THESE SYMBOLS SET TO
   ANY REASONABLE VALUE...
*)
SYMTAB_LEN	= 1000;		(* THE MAXIMUM NUMBER OF USER DEFINED SYMBOLS *)
SRCLIN_LEN	= 80;		(* THE MAXIMUM NUMBER OF CHARACTERS IN A SINGLE SOURCE LINE *)
LN_PAGE		= 55;		(* THE NUMBER OF LINES PRINTED ON ONE PAGE OF LISTING *)
IDENT_LEN	= 10;		(* THE NUMBER OF SIGNIFICANT CHARACTERS IN AN IDENTIFIER *)



(*
       THESE   CONSTANTS  DEFINE  SPECIAL  CHARACTERS  IN  THE  SOURCE
    LANGAUGE; (E.G. INDIRECT FLAGS, LITERALS, PESUDO-OPS, ETC)...
*)
CH_COM		= ';';		(* THE COMMENTING CHARACTER *)
CH_IND		= '@';		(* SELECTS INDIRECT ADDRESSING MODE *)
CH_LIT		= '[';		(* MARKS THE START OF A LITERAL *)
CH_LTE		= ']';		(*   "    "  END    " "    "    *)
CH_PMR		= '.';		(*   "    "  START OF A PSEUDO-OP *)
CH_RPC		= '.';		(* RETURNS THE CURRENT INSTRUCTION LOCATION *)
CH_RPO		= '*';		(* THE OLDER VERSION OF ABOVE *)
CH_QTE		= '"';		(* THE MARKER FOR A QUOTED STRING *)
CH_TAB		= CHR(9);	(* ASCII HORIZONTAL TAB CHARACTER *)
CH_FFD		= CHR(12);	(* ASCII FORM FEED CHARACTER *)
CH_NUL		= CHR(0);	(* ASCII NULL CHARACTER *)




(*
       THIS  SYMBOL  DEFINES  THE TITLE STRING WHICH IS PRINTED IN THE
    ASSEMBLY LISTING, AND ON THE USER'S TERMINAL... 
*)
TITLE_STRING	= 'PALX - Intersil IM6100 Assembly Language  V2.3  RLA';




(*
      THE  FOLLOWING  CONSTANTS  ARE REALLY DETERMINED BY THE TYPE OF
   MACHINE  THE  CODE  IS BEING ASSEMLED FOR. CONSTANTS ARE USED HERE
   (INSTEAD  OF  JUST WRITING THE ACTUAL NUMERIC VALUE) FOR THE ADDED
   MNEMONIC FLAVOR... NORMALLY THESE VALUSE WOULD NEVER BE CHANGED...
*)
OPTAB_LEN	= 100;		(* THE NUMBER OF MACHINE OPCODES *)
POPTAB_LEN	= 9;		(* THE NUMBER OF PSEUDO-OPS *)
CODE_LEN	= 4;		(* THE NUMBER OF DIGITS IN THE GENERATED CODE *)
ADDRESS_LEN	= 4;		(* THE NUMBER OF DIGITS IN AN ADDRESS *)
MAXIMUM_NUMBER	= 4095;		(* THE LARGEST LEGAL VALUE FOR AN ADDRESS *)
PAGE_SIZE	= 128; {0200B}	(* THE NUMBER OF WORDS ON A PAGE OF CODE *)
IBIT		= 256; {0400B}	(* THE INDIRECT ADDRESSING BIT *)
RBIT		= 128; {0200B}	(* THE CURRENT PAGE ADDRESSING BIT *)



(*
      THE  FOLLOWING  CONSTANTS  ARE  USED  INTERNALLY  FOR  MNEMONIC
   PURPOSES ONLY. NONE OF THEM SHOULD EVER BE CHANGED...
*)
CH_EOL		= '\';		(* THE INTERNAL MARKER USED FOR THE END OF LINE *)
CHAR_STR_LEN	= 80;		(* THE LENGTH OF AN INTERNAL MESSAGE STRING *)
LSTLIN_LEN	= 132;		(* THE LENGTH OF AN INTERNAL LIST LINE *)




(*
       THE  FOLLOWING  CONST'S  ARE USED AS FLAGS TO THE LIST ROUTINE;
    THEIR USE IS MORE FULLY DESCRIBED THERE... 
*)
LF_LBL = 1;   LF_LAD = 2;   LF_LAC = 3;   LF_LCD = 4;
LF_LTX = 5;   LF_LNT = 6;




(*
      THESE CONSTANTS REPRESENT VARIOUS STATEMENT TYPES... THEIR 
   ACTUAL NUMERIC VALUE IS NOT IMPORTANT... 
*)
ST_END = 1;   ST_ORG = 2;   ST_DAT = 3;   ST_TTL = 4;
ST_ASZ = 5;   ST_ZER = 6;   ST_EJEC= 7;   ST_SIX= 8;
ST_OPD = 9;   ST_EQU = 10;  ST_MACH= 11;  ST_NUL = 12;
ST_UNK = 13;




(*
      THE  FOLLOWING  CONSTANTS  DETERMINE THE ERROR CODES PRINTED IN
   THE  LISTING  AT  THE  START  OF  THE  BAD LINE... EACH ERROR CODE
   CONSISTS  OF  A  SINGLE  LETTER  (A .. Z); EXCEPT FOR ARGUMENTS TO
   ERRMSG, WHICH CONSIST OF 80 CHARACTER STRINGS...
*)
ER_IFN		= 'N';		(* ILLEGAL FORMAT FOR NUMBER *)
ER_SYM		= 'S';		(* A SYMBOL IN THIS STATEMENT HAS BEEN IMPROPERLY DEFINED *)
ER_UDF		= 'U';		(* THIS STATEMENT USES A SYMBOL WHICH HAS NOT YET BEEN DEFINED *)
ER_MDF		= 'M';		(* THIS SYMBOL IS MULTIPLY DEFINED *)
ER_SYN		= 'X';		(* SYNTAX ERROR... *)
ER_RAN		= 'A';		(* NUMBER OUT OF RANGE... *)
ER_PAF		= 'P';		(* PAGE FULL ERROR *)
ER_MIC		= 'O';		(* ILLEGAL MICRO-CODED COMBINATION *)
ER_SCT		= 'W';		(* ILLEGAL OFF PAGE REFERENCE *)




(*
       THESE  CONSTANTS  DEFINE CERTAIN STRING USED AS MESSAGES BY THE
    PROGRAM.   NOTE  THAT  SINCE  THESE  ARE  USED  AS  ARGUMENTS  FOR
    SUBROUTINES, EACH MUST HAVE EXACTLY THE RIGHT NUMBER OF CHARACTERS
    (INCLUDING TRAILING BLANKS...).
*)
ER_PBR	= 'PALX - Program break is                                                         ';
ER_NED	= 'PALX - No errors detected                                                       ';
ER_TED	= 'PALX -                                                                          ';
ER_TE2	= ' errors detected                                                                ';
SYMMSG	= 'Symbol Table                                                                    ';
ER_NCA	= 'PALX - Symbol table full                                                        ';








(*
	***** T Y P E   D E C L A R A T I O N S *****
*)
TYPE




(*
      THESE  TYPES  DEFINE  INDEX  FOR THE MORE POPULAR TABLES IN THE
   PROGRAM...
*)
SYMTAB_INDEX	= 0..SYMTAB_LEN;	(* INDEX INTO THE USER DEFINED SYMBOL TABLE *)
OPTAB_INDEX	= 0..OPTAB_LEN;		(* INDEX INTO THE MACHINE OPERATOR TABLE *)
POPTAB_INDEX	= 0..POPTAB_LEN;	(* AND INDEX INTO THE PSEUDO-OP TABLE *)




(*
      THE   FOLLOWING  TYPES  DETERMINE  THE  CHARACTERISTICS  OF  AN
   IDENTIFIER...
*)
IDENT_INDEX	= 1..IDENT_LEN;		(* A SUBSCRIPT FOR AN IDENTIFIER *)
IDENTIFIER	=			(* THE ACTUAL IDENTIFIER... *)
		  PACKED ARRAY [IDENT_INDEX] OF CHAR;




(*
      THESE  TYPES  DETERMINE  THE REPRESENTATION OF SEVERAL TYPES OF
   STRINGS USED INTERNALLY...
*)
LSTLIN_INDEX	= 1..LSTLIN_LEN;	(* THE SIZE OF A LIST STRING *)
SRCLIN_INDEX	= 1..SRCLIN_LEN;	(* A STRING READ FROM THE SOURCE FILE *)
CHAR_STR_INDEX	= 1..CHAR_STR_LEN;	(* AND THE SIZE OF A CHARACTER STRING *)
CHAR_STRING	=			(* AN INTERNAL CHARACTER STRING... *)
		  PACKED ARRAY [CHAR_STR_INDEX] OF CHAR;
LSTLIN_STRING	=			(* A STRING TO BE PRINTED IN THE LIST FILE *)
		  PACKED ARRAY [LSTLIN_INDEX] OF CHAR;
SRCLIN_STRING	=			(* AN EDITED STRING FROM THE SOURCE FILE... *)
		  PACKED ARRAY [SRCLIN_INDEX] OF CHAR;




(*
      THESE  TYPES  DETERMINE  SOME  COMMON NUMERIC TYPES WITHIN THIS
   PROGRAM...
*)
PINTEGER	= 0..MAXINT;		(* NON-NEGATIVE INTEGER *)
PDP_WORD	= 0..MAXIMUM_NUMBER;	(* A TARGET MACHINE WORD *)
OPCODE_TYPE	= (MRI, OPR, IOT,
                   PIE, PIO, CXF);     	(* THE TYPE OF AN OPCODE *)




(*
      THIS RECORD DEFINES AN ENTRY IN THE USER SYMBOL TABLE ...
*)
SYMTAB_ENTRY	=  RECORD
			NAME   : IDENTIFIER;	(* THE NAME OF THE SYMBOL *)
			VAL    : PDP_WORD;	(* THE VALUE OF THE SYMBOL *)
			SF_TAG : BOOLEAN;	(* TRUE IF THIS SYMBOL WAS DEFINED AS A TAG.. *)
			SF_EQU : BOOLEAN;	(* TRUE IF THIS SYMBOL WAS DEFINED BY AN EQUATE *)
			SF_OPD : BOOLEAN;	(* TRUE IF THIS SYMBOL IS AN OPDEF *)
			SF_UDF : BOOLEAN;	(* FLAG THAT  INDICATES THE SYMBOL IS UNDEFINED *)
			SF_MDF : BOOLEAN	(* FLAG THAT INDICATES THE SYMBOL IS MULTIPLY DEFINED *)
		  END;




(*
      THIS RECORD DEFINES AN ENTRY IN THE MACHINE OPCODE TABLE... 
*)
OPTAB_ENTRY	=  RECORD
			NAME  : IDENTIFIER;	(* THE NAME OF THE OPCODE *)
			OPCODE : PDP_WORD;	(* THE VALUE OF THIS OPCODE *)
			MODE   : OPCODE_TYPE	(* AND THE MODE IMPLIED HERE *)
		  END;




(*
      THIS RECORD DEFINES AN ENTRY IN THE PSEUDO-OP TABLE...
*)
POPTAB_ENTRY	=  RECORD
			NAME  : IDENTIFIER;	(* THE NAME OF THE PSEUDO-OP *)
			VAL   : PINTEGER	(* AND THE VALUE OF THE PSEUDO-OP *)
		  END;








(*
	***** V A R I A B L E   D E C L A R A T I O N S *****
*)
VAR




(*
      THESE VARIABLES CONTAIN ALL THE SYMBOL TABLES...
*)
SYMTAB		:			(* THE USER DEFINED SYMBOL TABLE *)
		  ARRAY [SYMTAB_INDEX] OF SYMTAB_ENTRY;
OPTAB		:			(* THE MACHINE OPCODE TABLE *)
 		  ARRAY [OPTAB_INDEX] OF OPTAB_ENTRY;
POPTAB		:			(* AND THE PSEUDO-OP TABLE *)
		  ARRAY [POPTAB_INDEX] OF POPTAB_ENTRY;




(*
      THESE  VARIABLES  CONTAIN  ALL  THE  STRINGS  PROCESSED IN THIS
   PROGRAM...
*)
SRCLIN,					(* THE EDITED SOURCE STRING *)
SRCLNU		: SRCLIN_STRING;	(* AND THE UNEDITED SOURCE STRING *)
LSTLIN		: LSTLIN_STRING;	(* STRINGS TO BE PRINTED IN THE LIST FILE *)
BLANK_LINE	: SRCLIN_STRING;	(* A BLANK INPUT LINE *)
CURSRI		: 0..CHAR_STR_LEN;	(* POINTER TO THE INPUT STRING *)
CURSRO		: 0..LSTLIN_LEN;	(* AND POINTER TO THE OUTPUT (LIST) STRING *)




(*
      THE FOLLOWING VARIABLES ARE ALL USED AS FLAGS....
*)
PASS_1,					(* SET IF THE ASSEMBLER IS UNDER PASS 1 *)
PASS_2,					(*  "   "   "      "     "   "     "  2 *)
FL_ERR,					(* SET IF THERE HAS BEEN AN ERROR IN THE CURRENT STATEMENT *)
FL_PAGE					(* SET IF WE NEED TO START A NEW PAGE IN THE LISTING *)
		: BOOLEAN;




(*
      THESE VARIABLES ARE ALL USED TO MAINTAN THE LITERAL TABLE...
*)
LITERALS	: ARRAY [0..PAGE_SIZE] OF PDP_WORD;	(* THIS CONTANS THE ACTUAL LITERALS *)
LITERAL_BASE	: INTEGER;				(* THIS POINTS TO THE ADDRESS OF THE LAST LITERAL *)




(*
      THESE VARIABLES ARE USED AS COUNTERS WITHIN THE PROGRAM...
*)
LINEK,					(* COUNTS THE LINES PRINTED IN THE LISTING *)
PAGEK,					(* COUNTS THE PAGES PRINTED IN THE LISTING *)
LINPAK,					(* COUNTS THE NUMBER OF LINES PRINTED ON THIS PAGE *)
ERRORK					(* COUNTS THE NUMBER OF ERRORS IN THE CURRENT PROGRAM *)
		: PINTEGER;




(*
      MISCELANEOUS....
*)
ERRCOD		:			(* REMEMBERS THE ERROR LETTERS FOR THIS STATEMENT *)
		  PACKED ARRAY [0..25] OF BOOLEAN;
IDENT_CHARS	: SET OF CHAR;		(* CONTAINS ALL CHARACTERS LEGAL IN AN IDENTIFIER *)
BLANK_ID	: IDENTIFIER;		(* A NULL IDENTIFIER NAME... *)
NULL_CODE	: PDP_WORD;		(* A COMPLETELY ZERO INSTRUCTION *)
GENCODE		: PDP_WORD;		(* HOLDS THE GENERATED MICRO-INSTRUCTION *)
PC		: PDP_WORD;		(* HOLDS THE ADDRESS OF THE CURRENT INSTRUCTION *)
CHECKSUM	: INTEGER;		(* THE CHECKSUM OF THE BINARY CODE *)
LAST_ADDR	: PDP_WORD;		(* THE LAST ADDRESS WRITTEN TO THE OBJECT FILE *)
TAG_FIELD	: IDENTIFIER;		(* THE CONTENTS OF THE STATEMENT'S TAG FIELD *)
PROGRAM_TITLE	: SRCLIN_STRING;	(* THE USER'S PROGRAM TITLE *)




(*
      AND  FINALLY  THESE  PARAMETERS  DEFINE THE 3 FILES USED IN THE
   ASSEMBLER ...
*)
LISTFILE	: TEXT;			(* THE SOURCE PROGRAM LISTING FILE *)
SOURCEFILE	: TEXT;			(* THE SOURCE PROGRAM INPUT FILE *)
OBJECTFILE	: TEXT;			(* AND THE GENERATED CODE FILE *)








(*
	***** I N I T I A L I Z A T I O N *****

      THESE   ROUTINES  INITIALIZE  ALL  DATA  AREAS  NEEDED  BY  THE
   ASSEMBLER. THESE DATA AREAS CAN BE DIVIDED INTO TWO PARTS: (1) THE
   PURE DATA (THAT WHICH IS NEVER CHANGED (LIKE AN OPCODE TABLE), AND
   (2)  THE  IMPURE  DATA  (THAT WHICH IS CHANGED (LIKE A USER SYMBOL
   TABLE)).  THE  PURE  DATA  AREAS  ARE ASSIGNED VIA DEC-10 PASCAL'S
   INITPROCEDURE  FEATURE; THE IMPURE AREAS ARE DYNAMICALLY SET UP BY
   A NORMAL ROUTINE. THIS ALLOWS THE ASSEMBLER TO BE RESTARTABLE...
*)




(*
      THIS  IS  THE  MACHINE  OPCODE  TABLE... IN THIS ASSEMBLER THIS
   TABLE  CONTAINS  THE  NAMES  AND  NUMBERS  OF ALL THE OPCODES IN THE
   HARDWARE. THE MACHINE OPCODE TABLE CONSISTS OF 3 FIELDS:

	.NAME    -- THE NAME OF THE OPCODE (INCLUDING THE MODE)

	.OPCODE  -- THE NUMERIC OPCODE VALUE

	.MODE    -- THE MODE IMPLIED BY THIS MNEMONIC

      THIS  TABLE  IS  DEFINED  VIA  AN INITPROCEDURE BECAUSE IT WILL
   NEVER CHANGE...
*)
PROCEDURE OPTAB_INIT;
BEGIN

  OPTAB[01].NAME := 'AND       ';   OPTAB[01].MODE := MRI;   OPTAB[01].OPCODE := 0000; {0000B}
  OPTAB[02].NAME := 'TAD       ';   OPTAB[02].MODE := MRI;   OPTAB[02].OPCODE :=  512; {1000B}
  OPTAB[03].NAME := 'ISZ       ';   OPTAB[03].MODE := MRI;   OPTAB[03].OPCODE := 1024; {2000B}
  OPTAB[04].NAME := 'DCA       ';   OPTAB[04].MODE := MRI;   OPTAB[04].OPCODE := 1536; {3000B}
  OPTAB[05].NAME := 'JMS       ';   OPTAB[05].MODE := MRI;   OPTAB[05].OPCODE := 2048; {4000B}
  OPTAB[06].NAME := 'JMP       ';   OPTAB[06].MODE := MRI;   OPTAB[06].OPCODE := 2560; {5000B}
  OPTAB[07].NAME := 'NOP       ';   OPTAB[07].MODE := OPR;   OPTAB[07].OPCODE := 3584; {7000B}
  OPTAB[08].NAME := 'IAC       ';   OPTAB[08].MODE := OPR;   OPTAB[08].OPCODE := 3585; {7001B}
  OPTAB[09].NAME := 'RAL       ';   OPTAB[09].MODE := OPR;   OPTAB[09].OPCODE := 3588; {7004B}
  OPTAB[10].NAME := 'RTL       ';   OPTAB[10].MODE := OPR;   OPTAB[10].OPCODE := 3590; {7006B}
  OPTAB[11].NAME := 'RAR       ';   OPTAB[11].MODE := OPR;   OPTAB[11].OPCODE := 3592; {7010B}
  OPTAB[12].NAME := 'RTR       ';   OPTAB[12].MODE := OPR;   OPTAB[12].OPCODE := 3594; {7012B}
  OPTAB[13].NAME := 'BSW       ';   OPTAB[13].MODE := OPR;   OPTAB[13].OPCODE := 3586; {7002B}
  OPTAB[14].NAME := 'CML       ';   OPTAB[14].MODE := OPR;   OPTAB[14].OPCODE := 3600; {7020B}
  OPTAB[15].NAME := 'CMA       ';   OPTAB[15].MODE := OPR;   OPTAB[15].OPCODE := 3616; {7040B}
  OPTAB[16].NAME := 'CIA       ';   OPTAB[16].MODE := OPR;   OPTAB[16].OPCODE := 3617; {7041B}
  OPTAB[17].NAME := 'CLL       ';   OPTAB[17].MODE := OPR;   OPTAB[17].OPCODE := 3648; {7100B}
  OPTAB[18].NAME := 'STL       ';   OPTAB[18].MODE := OPR;   OPTAB[18].OPCODE := 3664; {7120B}
  OPTAB[19].NAME := 'CLA       ';   OPTAB[19].MODE := OPR;   OPTAB[19].OPCODE := 3712; {7200B}
  OPTAB[20].NAME := 'GLK       ';   OPTAB[20].MODE := OPR;   OPTAB[20].OPCODE := 3716; {7204B}
  OPTAB[21].NAME := 'STA       ';   OPTAB[21].MODE := OPR;   OPTAB[21].OPCODE := 3744; {7240B}
  OPTAB[22].NAME := 'HLT       ';   OPTAB[22].MODE := OPR;   OPTAB[22].OPCODE := 3842; {7402B}
  OPTAB[23].NAME := 'OSR       ';   OPTAB[23].MODE := OPR;   OPTAB[23].OPCODE := 3844; {7404B}
  OPTAB[24].NAME := 'SKP       ';   OPTAB[24].MODE := OPR;   OPTAB[24].OPCODE := 3848; {7410B}
  OPTAB[25].NAME := 'SNL       ';   OPTAB[25].MODE := OPR;   OPTAB[25].OPCODE := 3856; {7420B}
  OPTAB[26].NAME := 'SZL       ';   OPTAB[26].MODE := OPR;   OPTAB[26].OPCODE := 3864; {7430B}
  OPTAB[27].NAME := 'SZA       ';   OPTAB[27].MODE := OPR;   OPTAB[27].OPCODE := 3872; {7440B}
  OPTAB[28].NAME := 'SNA       ';   OPTAB[28].MODE := OPR;   OPTAB[28].OPCODE := 3880; {7450B}
  OPTAB[29].NAME := 'SMA       ';   OPTAB[29].MODE := OPR;   OPTAB[29].OPCODE := 3904; {7500B}
  OPTAB[30].NAME := 'SPA       ';   OPTAB[30].MODE := OPR;   OPTAB[30].OPCODE := 3912; {7510B}
  OPTAB[31].NAME := 'LAS       ';   OPTAB[31].MODE := OPR;   OPTAB[31].OPCODE := 3972; {7604B}
  OPTAB[32].NAME := 'MQL       ';   OPTAB[32].MODE := OPR;   OPTAB[32].OPCODE := 3857; {7421B}
  OPTAB[33].NAME := 'MQA       ';   OPTAB[33].MODE := OPR;   OPTAB[33].OPCODE := 3905; {7501B}
  OPTAB[34].NAME := 'SWP       ';   OPTAB[34].MODE := OPR;   OPTAB[34].OPCODE := 3921; {7521B}
  OPTAB[35].NAME := 'CAM       ';   OPTAB[35].MODE := OPR;   OPTAB[35].OPCODE := 3985; {7621B}
  OPTAB[36].NAME := 'ACL       ';   OPTAB[36].MODE := OPR;   OPTAB[36].OPCODE := 4033; {7701B}
  OPTAB[37].NAME := 'SKON      ';   OPTAB[37].MODE := IOT;   OPTAB[37].OPCODE := 3072; {6000B}
  OPTAB[38].NAME := 'ION       ';   OPTAB[38].MODE := IOT;   OPTAB[38].OPCODE := 3073; {6001B}
  OPTAB[39].NAME := 'IOF       ';   OPTAB[39].MODE := IOT;   OPTAB[39].OPCODE := 3074; {6002B}
  OPTAB[40].NAME := 'SRQ       ';   OPTAB[40].MODE := IOT;   OPTAB[40].OPCODE := 3075; {6003B}
  OPTAB[41].NAME := 'GTF       ';   OPTAB[41].MODE := IOT;   OPTAB[41].OPCODE := 3076; {6004B}
  OPTAB[42].NAME := 'RTF       ';   OPTAB[42].MODE := IOT;   OPTAB[42].OPCODE := 3077; {6005B}
  OPTAB[43].NAME := 'CAF       ';   OPTAB[43].MODE := IOT;   OPTAB[43].OPCODE := 3079; {6007B}
  OPTAB[44].NAME := 'READ1     ';   OPTAB[44].MODE := PIE;   OPTAB[44].OPCODE := 3072; {6000B}
  OPTAB[45].NAME := 'READ2     ';   OPTAB[45].MODE := PIE;   OPTAB[45].OPCODE := 3080; {6010B}
  OPTAB[46].NAME := 'WRITE1    ';   OPTAB[46].MODE := PIE;   OPTAB[46].OPCODE := 3073; {6001B}
  OPTAB[47].NAME := 'WRITE2    ';   OPTAB[47].MODE := PIE;   OPTAB[47].OPCODE := 3081; {6011B}
  OPTAB[48].NAME := 'SKIP1     ';   OPTAB[48].MODE := PIE;   OPTAB[48].OPCODE := 3074; {6002B}
  OPTAB[49].NAME := 'SKIP2     ';   OPTAB[49].MODE := PIE;   OPTAB[49].OPCODE := 3075; {6003B}
  OPTAB[50].NAME := 'SKIP3     ';   OPTAB[50].MODE := PIE;   OPTAB[50].OPCODE := 3082; {6012B}
  OPTAB[51].NAME := 'SKIP4     ';   OPTAB[51].MODE := PIE;   OPTAB[51].OPCODE := 3083; {6013B}
  OPTAB[52].NAME := 'RCRA      ';   OPTAB[52].MODE := PIE;   OPTAB[52].OPCODE := 3076; {6004B}
  OPTAB[53].NAME := 'WCRA      ';   OPTAB[53].MODE := PIE;   OPTAB[53].OPCODE := 3077; {6005B}
  OPTAB[54].NAME := 'WCRB      ';   OPTAB[54].MODE := PIE;   OPTAB[54].OPCODE := 3085; {6015B}
  OPTAB[55].NAME := 'WVR       ';   OPTAB[55].MODE := PIE;   OPTAB[55].OPCODE := 3084; {6014B}
  OPTAB[56].NAME := 'SFLAG1    ';   OPTAB[56].MODE := PIE;   OPTAB[56].OPCODE := 3078; {6006B}
  OPTAB[57].NAME := 'SFLAG3    ';   OPTAB[57].MODE := PIE;   OPTAB[57].OPCODE := 3086; {6016B}
  OPTAB[58].NAME := 'CFLAG1    ';   OPTAB[58].MODE := PIE;   OPTAB[58].OPCODE := 3079; {6007B}
  OPTAB[59].NAME := 'CFLAG3    ';   OPTAB[59].MODE := PIE;   OPTAB[59].OPCODE := 3087; {6017B}
  OPTAB[60].NAME := 'SETPA     ';   OPTAB[60].MODE := PIO;   OPTAB[60].OPCODE := 3264; {6300B}
  OPTAB[61].NAME := 'CLRPA     ';   OPTAB[61].MODE := PIO;   OPTAB[61].OPCODE := 3265; {6301B}
  OPTAB[62].NAME := 'WPA       ';   OPTAB[62].MODE := PIO;   OPTAB[62].OPCODE := 3266; {6302B}
  OPTAB[63].NAME := 'RPA       ';   OPTAB[63].MODE := PIO;   OPTAB[63].OPCODE := 3267; {6303B}
  OPTAB[64].NAME := 'SETPB     ';   OPTAB[64].MODE := PIO;   OPTAB[64].OPCODE := 3268; {6304B}
  OPTAB[65].NAME := 'CLRPB     ';   OPTAB[65].MODE := PIO;   OPTAB[65].OPCODE := 3269; {6305B}
  OPTAB[66].NAME := 'WPB       ';   OPTAB[66].MODE := PIO;   OPTAB[66].OPCODE := 3270; {6306B}
  OPTAB[67].NAME := 'RPB       ';   OPTAB[67].MODE := PIO;   OPTAB[67].OPCODE := 3271; {6307B}
  OPTAB[68].NAME := 'SETPC     ';   OPTAB[68].MODE := PIO;   OPTAB[68].OPCODE := 3272; {6310B}
  OPTAB[69].NAME := 'CLRPC     ';   OPTAB[69].MODE := PIO;   OPTAB[69].OPCODE := 3273; {6311B}
  OPTAB[70].NAME := 'WPC       ';   OPTAB[70].MODE := PIO;   OPTAB[70].OPCODE := 3274; {6312B}
  OPTAB[71].NAME := 'RPC       ';   OPTAB[71].MODE := PIO;   OPTAB[71].OPCODE := 3275; {6313B}
  OPTAB[72].NAME := 'SKPOR     ';   OPTAB[72].MODE := PIO;   OPTAB[72].OPCODE := 3276; {6314B}
  OPTAB[73].NAME := 'SKPIR     ';   OPTAB[73].MODE := PIO;   OPTAB[73].OPCODE := 3277; {6315B}
  OPTAB[74].NAME := 'WSR       ';   OPTAB[74].MODE := PIO;   OPTAB[74].OPCODE := 3278; {6316B}
  OPTAB[75].NAME := 'RSR       ';   OPTAB[75].MODE := PIO;   OPTAB[75].OPCODE := 3279; {6317B}
  OPTAB[76].NAME := 'CDF       ';   OPTAB[76].MODE := CXF;   OPTAB[76].OPCODE := 3201; {6201B}
  OPTAB[77].NAME := 'CIF       ';   OPTAB[77].MODE := CXF;   OPTAB[77].OPCODE := 3202; {6202B}
  OPTAB[78].NAME := 'CXF       ';   OPTAB[78].MODE := CXF;   OPTAB[78].OPCODE := 3203; {6203B}
  OPTAB[79].NAME := 'RDF       ';   OPTAB[79].MODE := IOT;   OPTAB[79].OPCODE := 3212; {6214B}
  OPTAB[80].NAME := 'RIF       ';   OPTAB[80].MODE := IOT;   OPTAB[80].OPCODE := 3220; {6224B}
  OPTAB[81].NAME := 'RIB       ';   OPTAB[81].MODE := IOT;   OPTAB[81].OPCODE := 3228; {6234B}
  OPTAB[82].NAME := 'RMF       ';   OPTAB[82].MODE := IOT;   OPTAB[82].OPCODE := 3236; {6244B}
  OPTAB[83].NAME := 'LIF       ';   OPTAB[83].MODE := IOT;   OPTAB[83].OPCODE := 3244; {6254B}
  OPTAB[84].NAME := 'CLZE      ';   OPTAB[84].MODE := IOT;   OPTAB[84].OPCODE := 3160; {6130B}
  OPTAB[85].NAME := 'CLSK      ';   OPTAB[85].MODE := IOT;   OPTAB[85].OPCODE := 3161; {6131B}
  OPTAB[86].NAME := 'CLOE      ';   OPTAB[86].MODE := IOT;   OPTAB[86].OPCODE := 3162; {6132B}
  OPTAB[87].NAME := 'CLAB      ';   OPTAB[87].MODE := IOT;   OPTAB[87].OPCODE := 3163; {6133B}
  OPTAB[88].NAME := 'CLEN      ';   OPTAB[88].MODE := IOT;   OPTAB[88].OPCODE := 3164; {6134B}
  OPTAB[89].NAME := 'CLSA      ';   OPTAB[89].MODE := IOT;   OPTAB[89].OPCODE := 3165; {6135B}
  OPTAB[90].NAME := 'CLBA      ';   OPTAB[90].MODE := IOT;   OPTAB[90].OPCODE := 3166; {6136B}
  OPTAB[91].NAME := 'CLCA      ';   OPTAB[91].MODE := IOT;   OPTAB[91].OPCODE := 3167; {6137B}
  OPTAB[92].NAME := 'LCAR      ';   OPTAB[92].MODE := IOT;   OPTAB[92].OPCODE := 3205; {6205B}
  OPTAB[93].NAME := 'RCAR      ';   OPTAB[93].MODE := IOT;   OPTAB[93].OPCODE := 3213; {6215B}
  OPTAB[94].NAME := 'LWCR      ';   OPTAB[94].MODE := IOT;   OPTAB[94].OPCODE := 3221; {6225B}
  OPTAB[95].NAME := 'LEAR      ';   OPTAB[95].MODE := CXF;   OPTAB[95].OPCODE := 3206; {6206B}
  OPTAB[96].NAME := 'REAR      ';   OPTAB[96].MODE := IOT;   OPTAB[96].OPCODE := 3229; {6235B}
  OPTAB[97].NAME := 'LFSR      ';   OPTAB[97].MODE := IOT;   OPTAB[97].OPCODE := 3237; {6245B}
  OPTAB[98].NAME := 'RFSR      ';   OPTAB[98].MODE := IOT;   OPTAB[98].OPCODE := 3245; {6255B}
  OPTAB[99].NAME := 'WRVR      ';   OPTAB[99].MODE := IOT;   OPTAB[99].OPCODE := 3261; {6275B}
  OPTAB[100].NAME := 'SKOF      ';   OPTAB[100].MODE := IOT;   OPTAB[100].OPCODE := 3253; {6265B}

END;




(*
      THIS IS THE 'PSEUDO-OP' TABLE.... IN THIS PARTICULAR ASSEMBLER,
   IT   CONTAINS   ONLY   PSEUDO-OPS. THE TABLE HAS TWO ENTRIES:

	.NAME -- THE 10 CHARACTER NAME OF THE OP...

	.VALUE -- A NUMBER INDICATING THE OPCODE.  THIS NUMBER IS USED IN A
		CASE STATEMENT IN BOTH PASS_ONE AND PASS_TWO...

      THIS  TABLE  IS  DEFINED  BY  AN INITPROCEDURE BECAUSE IT NEVER
   CHANGES...
*)
PROCEDURE POPTAB_INIT;
BEGIN
  POPTAB[ST_END].NAME := 'END       ';	POPTAB[ST_END].VAL := ST_END;
  POPTAB[ST_ORG].NAME := 'ORG       ';	POPTAB[ST_ORG].VAL := ST_ORG;
  POPTAB[ST_DAT].NAME := 'DATA      ';	POPTAB[ST_DAT].VAL := ST_DAT;
  POPTAB[ST_TTL].NAME := 'TITLE     ';	POPTAB[ST_TTL].VAL := ST_TTL;
  POPTAB[ST_ASZ].NAME := 'ASCIZ     ';	POPTAB[ST_ASZ].VAL := ST_ASZ;
  POPTAB[ST_ZER].NAME := 'BLOCK     ';	POPTAB[ST_ZER].VAL := ST_ZER;
  POPTAB[ST_SIX].NAME := 'SIXBIT    ';	POPTAB[ST_SIX].VAL := ST_SIX;
  POPTAB[ST_EJEC].NAME := 'EJECT     ';	POPTAB[ST_EJEC].VAL := ST_EJEC;
  POPTAB[ST_OPD].NAME := 'OPDEF     ';	POPTAB[ST_OPD].VAL := ST_OPD;
END;




(*
      THIS  ROUTINE  INITIALIZES  ALL  IMPURE  DATA AREAS (I.E. THOSE
   WHICH  ARE CHANGED DURING ASSEMBLY)... IT IS CALLED JUST AFTER THE
   ASSEMBLER IS STARTED UP...
*)
PROCEDURE  START_UP;
VAR   K : PINTEGER;
BEGIN

  (* INITIALIZE ALL TYPES AND SETS... *)
  FOR   K := 0  TO  25   DO   ERRCOD[K] := FALSE;
  IDENT_CHARS := ['A'..'Z', '0'..'9', '_', '$', '%'];
  BLANK_ID := '          ';
  FOR  K := 1  TO  SRCLIN_LEN   DO  BLANK_LINE[K] := ' ';

  (* CLEAR OUT THE USER DEFINED SYMBOL TABLE... *)
  FOR   K := 0  TO  SYMTAB_LEN   DO
    BEGIN
      SYMTAB[K].NAME := BLANK_ID;  SYMTAB[K].VAL := 0;
      SYMTAB[K].SF_TAG := FALSE;   SYMTAB[K].SF_EQU := FALSE;
      SYMTAB[K].SF_MDF := FALSE;   SYMTAB[K].SF_UDF := FALSE;
      SYMTAB[K].SF_OPD := FALSE

    END;

  (* CLEAR OUT ALL THE FLAGS... *)
  PASS_1 := FALSE;   PASS_2 := FALSE;
  FL_ERR := FALSE;   FL_PAGE := FALSE;

  (* ZERO ALL GLOBAL COUNTERS... *)
  LINEK := 0;    LINPAK := 1;   ERRORK := 0;
  
  (* SET UP THE NULL CODE RECORD... *)
  NULL_CODE := 0;

  (* INITIALIZE THE OBJECT FILE OUTPUT ROUTINES... *)
  LAST_ADDR := MAXIMUM_NUMBER;

  (* CLEAR OUT THE TITLE STRING *)
  PROGRAM_TITLE := BLANK_LINE;

  (* INITIALIZE INTERNAL SYMBOL TABLES *)
  OPTAB_INIT;  POPTAB_INIT;

END;








(*
	***** F O R W A R D   R E F E R E N C E S *****
*)
PROCEDURE  ERRMSG (ERRSTR : CHAR_STRING);   FORWARD;

PROCEDURE  CERR (ERRCHR : CHAR);   FORWARD;

PROCEDURE  SPACES (NUMBER : PINTEGER);   FORWARD;

PROCEDURE  PRTR50(SYMSTR : IDENTIFIER);   FORWARD;

FUNCTION MACHOP (INDEX : OPTAB_INDEX;   VAR VAL : PDP_WORD) : BOOLEAN;   FORWARD;

FUNCTION MRI_EVAL (VAR VAL : PDP_WORD) : BOOLEAN;   FORWARD;

FUNCTION  SCNARI (VAR  AC : PDP_WORD)  : BOOLEAN;   FORWARD;








(*
	***** S Y M B O L   T A B L E   M A N A G E M E N T *****

      THESE   ROUTINES   PROVIDE  ALL  THE  SYMBOL  TABLE  MANAGEMENT
   FUNCTIONS  REQUIRED  FOR  SMILES. THIS INCLUDES ROUTINES TO LOOKUP
   SYMBOLS IN THE PSEUDO-OP TABLE, MACHINE OPCODE TABLE, AND THE USER
   DEFINED SYMBOL (TAG OR LABEL) TABLE. ALL SYMBOLS IN SMILES CONSIST
   OF 10 CHARACTERS, WHICH ARE PACKED INTO A PACKED ARRAY OF CHAR....

      THE  MACHINE OPCODE AND PSEUDO-OP TABLE SEARCH ROUTINES PERFORM
   A  SIMPLE  LINEAR SEARCH FOR THEIR ARGUMENTS. THIS IS SATISFACTORY
   BECUASE  BOTH OF THESE TABLES ARE EXTREMELY SHORT AND IT THUS DOES
   NOT  REQUIRE A LARGE AMOUNT OF TIME TO SEARCH THEM. A HASHED TABLE
   WOULD  BE  EXTERMELY INEFFICIENT HERE, BECAUSE OF THE WASTED SPACE
   IN THE TABLE AND THE DIFFICULTY IN SETTING UP A PRE-DEFINED HASHED
   TABLE...

      THE  USER  DEFINED  SYMBOL  TABLE  ROUTINES  USE A HASHED TABLE
   SEARCH  ALGORITHM,  JUST  AS  WAS REQUIRED IN THE ASSIGNMENT. (THE
   ACTUAL  PRACTICAL  VALUE  OF THIS IDEA IS QUESTIONABLE, BECAUSE OF
   THE  FANTASTIC AMOUNT OF OVERHEAD REQUIRED TO GENERATE THE HASHING
   CODE...)  COLLISIONS  ARE  RESOLVED  BY  SIMPLY SEARCHING LINEARLY
   FORWARD  FOR THE NEXT FREE SPACE IN THE TABLE. NOTE THAT A HASHING
   SCHEME  REQUIRES A TABLE OF FIXED SIZE, THUS THE ROUTINE TO DEFINE
   A  SYMBOL  WILL  CALL  ERRMSG  TO PRINT A FATAL ERROR IF THE TABLE
   OVERFLOWS...

      ALL  LOOKUP  ROUTINES  ARE  FUNCTIONS WHICH RETURN THE VALUE OF
   TRUE  IF  THE  SYMBOL  IS FOUND, AND FALSE IF IT IS NOT. AS A SIDE
   EFFECT,   THE  ROUTINE  WILL  ALSO  RETURN  THE  INDEX  INTRO  THE
   APPROPRIATE TABLE OF THE SYMBOL (IF IT IS FOUND).


   THE FOLLOWING ROUTINES ARE PROVIDED...
	DEFSYM	-- INSERT SYMBOL IN USER DEFINED SYMBOL TABLE
	VALSYM	-- LOOKUP SYMBOL "    "     "      "      "
	VALPOP	-- LOOKUP SYMBOL IN PSEUDO-OP TABLE
	VALOP	-- LOOKUP SYMBOL IN MACHINE OP TABLE

*)




(*
      THIS  ROUTINE  PERFORMS  A  SIMPLE LINEAR SEARCH OF THE MACHINE
   OPCODE  TABLE  TO FIND THE SPECIFIED OPCODE. RETURNS TRUE IF IT IS
   FOUND,  AND  FALSE  IF  IT  IS NOT. THE ARGUMENT INDEX RETURNS THE
   RELATIVE TABLE INDEX IN OPTAB OF THE OPCODE (IF IT IS FOUND).
*)
FUNCTION VALOP (OPCODE : IDENTIFIER;   VAR  INDEX : OPTAB_INDEX)  :  BOOLEAN;
VAR   FOUND : BOOLEAN;
BEGIN

  INDEX := 0;   FOUND := FALSE;
  REPEAT
    INDEX := INDEX + 1;
    IF OPTAB[INDEX].NAME = OPCODE  THEN   FOUND := TRUE
  UNTIL  (INDEX = OPTAB_LEN)  OR  (FOUND);
  VALOP := FOUND

END;




(*
      THIS  ROUTINE  PERFORMS A SIMPLE LINEAR SEARCH OF THE PSEUDO-OP
   TABLE  TO  FIND THE SPECIFIED OPCODE. RETURNS TRUE IF IT IS FOUND,
   AND  FALSE  IF  IT IS NOT. THE ARGUMENT INDEX RETURNS THE RELATIVE
   INDEX INTO POPTAB OF THE OPCODE (IF IT IS FOUND).
*)
FUNCTION  VALPOP  (POPCODE : IDENTIFIER;   VAR  INDEX : POPTAB_INDEX)  :  BOOLEAN;
VAR   FOUND : BOOLEAN;
BEGIN

  INDEX := 0;   FOUND := FALSE;
  REPEAT
    INDEX := INDEX + 1;
    IF POPTAB[INDEX].NAME = POPCODE  THEN   FOUND := TRUE
  UNTIL  (INDEX = POPTAB_LEN)  OR  (FOUND);
  VALPOP := FOUND

END;




(*
      THIS ROUTINE IS LOCALLY USED BY THE HASH TABLE SEARCH ROUTINES.
   IT  GENERATES  THE HASH CODE FOR A GIVEN IDENTIFIER. THE HASH CODE
   IS GENERATED BY FORMING A BINARY EQUIVALENT FOR THE ORDINAL VALUES
   OF  THE 10 CHARACTERS, AND THEN DIVIDING BY THE TABLE LENGTH. THIS
   IS  EXACTLY  THE  SAME METHOD AS DESCRIBED IN THE ASSIGNMENT. NOTE
   THAT SINCE THIS IS A VERY POPULAR ROUTINE, IT IS TO OUR BENEFIT TO
   CODE IT AS EFFICIENTLY AS POSSIBLE...
*)
FUNCTION  HASH_CODE  (SYMBOL : IDENTIFIER)  :  SYMTAB_INDEX;
VAR   K, VAL1, VAL2  : INTEGER;
BEGIN

  VAL1 := 0;   VAL2 := 0;
  FOR  K := 1  TO  5   DO  VAL1 := VAL1*(ORD('_')) + ORD(SYMBOL[K])-ORD(' ');
  FOR  K := 6  TO  10  DO  VAL2 := VAL2*(ORD('_')) + ORD(SYMBOL[K])-ORD(' ');
  HASH_CODE := (VAL1 + VAL2) MOD SYMTAB_LEN

END;




(*
      THIS  ROUTINE  PERFORMS  A  HASHED  SEARCH  OF THE USER DEFINED
   SYMBOL  TABLE TO FIND THE SPECIFIED SYMBOL. IT RETURNS TRUE IF THE
   SYMBOL  IS  FOUND, AND FALSE IF IT IS NOT. IF THE SYMBOL IS FOUND,
   THEN THE ARGUMENT INDEX WILL RETURN THE RELATIVE INDEX INTO SYMTAB
   FOR THE SYMBOL....
*)
FUNCTION  VALSYM  (SYMBOL : IDENTIFIER;   VAR  INDEX : SYMTAB_INDEX)  :  BOOLEAN;
VAR   START : SYMTAB_INDEX;    FOUND, FINISH  :  BOOLEAN;
BEGIN

  (* COMPUTE THE LOCTATION FOR THE INITIAL STAB AT THE TABLE... *)
  START := HASH_CODE (SYMBOL);
  FOUND := FALSE;   INDEX := START;   FINISH := FALSE;

  (* START AT THE INITIAL LOCATION, AND SEARCH LINEARLY DOWNWARD
    UNTIL THE SYMBOL IS FOUND... *)
  REPEAT

    (* WE'VE FINISHED WHEN WE COME TO AN EMPTY SPOT IN THE TABLE... *)
    IF  SYMTAB[INDEX].NAME = BLANK_ID   THEN FINISH := TRUE

      (* OTHERWISE, HAVE WE FOUND THE RIGHT NAME ?? *)
      ELSE  IF  SYMTAB[INDEX].NAME = SYMBOL   THEN FOUND := TRUE

        (* NOT THERE -- RE-CIRCULATE AROUND TO THE NEXT ENTRY ... *)
        ELSE  IF  INDEX >= SYMTAB_LEN
          THEN  INDEX := 1   ELSE  INDEX := INDEX + 1

  (* QUIT WHEN WE'VE GONE ALL THE WAY AROUND, OR IF WE'RE DONE... *)
  UNTIL  (INDEX = START)  OR  FOUND  OR  FINISH;
  
  (* AND RETURN THE CORRECT VALUE... *)
  VALSYM := FOUND


END;




(*
      THIS  ROUTINE ENTERS A SYMBOL IN THE USER DEFINED SYMBOL TABLE.
   IF  THE  SYMBOL  ALREADY  EXISTS, THEN IT IS RE-DEFINED.... IF THE
   SYMBOL  TABLE  BECOMES FULL, THE THE ERRMSG ROUTINE WILL BE CALLED
   TO PRINT A MESSAGE AND EXIT THE PROGRAM...
*)
PROCEDURE  DEFSYM  (ENTRY : SYMTAB_ENTRY);
VAR   START, INDEX  :  SYMTAB_INDEX;
BEGIN

  (* COMPUTE THE ADDRESS FOR THE INITIAL STAB AT THE SYMBOL TABLE... *)
  START := HASH_CODE (ENTRY.NAME);
  INDEX := START;

  (* LOOP UNTIL WE FIND AN EMPRY SPOT OR THIS EXACT SYMBOL.... *)
  WHILE  (SYMTAB[INDEX].NAME <> BLANK_ID)   AND   (SYMTAB[INDEX].NAME <> ENTRY.NAME)
    DO  BEGIN

    (* RE-CIRCULATE AROUND TO THE NEXT ENTRY IN THE TABLE... *)
    IF  INDEX >=  SYMTAB_LEN
      THEN  INDEX := 1   ELSE  INDEX := INDEX + 1;

    (* HAVE GONE ALL THE WAY AROUND THE TABLE ?? *)
    IF  INDEX = START  THEN ERRMSG(ER_NCA)

    END;

  (* PUT THE NEW SYMBOL IN THE CORRECT PLACE IN THE TABLE... *)
  SYMTAB[INDEX] := ENTRY


END;

(*
      THIS PROCEDURE WILL SORT THE SYMBOL TABLE INTO ALPHABETICAL
   ORDER.  IT CURRENTLY USES A SIMPLE BUBBLE SORT ALGORITHM, SO DON'T
   HOLD YOUR BREATH.
*)
PROCEDURE  SORTSYM;
VAR   INDEX : SYMTAB_INDEX;  SORTED : BOOLEAN;  T : SYMTAB_ENTRY;
BEGIN

  REPEAT
    SORTED := TRUE;
    FOR   INDEX := 2   TO   SYMTAB_LEN   DO
      IF  (SYMTAB[INDEX-1].NAME > SYMTAB[INDEX].NAME)  THEN BEGIN
        T := SYMTAB[INDEX];  SYMTAB[INDEX] := SYMTAB[INDEX-1];
        SYMTAB[INDEX-1] := T;  SORTED := FALSE
      END
  UNTIL   SORTED

END;





(*
	***** S T R I N G   P R O C E S S I N G *****



      THESE  ROUTINES  PROVIDE  ALL  THE  STRING PROCESSING FUNCTIONS
   NEEDED  FOR  SCANNING AND PRINTING. THIS INCLUDES ROUTINES TO SCAN
   IDENTIFIERS  AND  NUMBERS;  AND ROUTINES TO PRINT IDENTIFIERS, AND
   NUMBERS  OF ANY SIZE AND RADIX. THESE FUNCTIONS ARE NEEDED BECAUSE
   THE PASCAL BUILT IN FUNCTIONS DO NOT PROVIDE ENOUGH VERSITILITY OR
   ERROR  CHECKING  FOR OUR NEEDS (BESIDES, A REAL SYSTEMS PROGRAMMER
   WOULD  HAVE  TO  WRITE  HIS OWN). NOTE THAT ALL OF THESE FUNCTIONS
   OPERATE  ON  THE  CHARACTER  TYPE CHAR, EVEN THOUGH THE SOURCE AND
   LIST FILES ARE TYPE TEXT...

      SEVERAL  ROUTINES  ARE  CHARACTER  MANIPIULATION  TYPES.  THESE
   RETURN  THE NEXT CHARACTER FROM THE INPUT STRING, OR INSERT ONE IN
   THE   OUTPUT   STRING,   ETC.   THESE  MIMIC  THE  PDP10  HARDWARE
   INSTRUCTIONS  TO  DO  THE SAME THING, AND ARE USED TO SIMPLIFY THE
   SCANNER  AND  PRINTER  ROUTINES.  NOTE  THAT  INPUT CHARACTERS ARE
   ALWAYS  SCANNED  FROM  THE  ARRAY  SRCLIN,  AND THE POINTER CURSRI
   POINTS TO THE CURRENT CHARACTER. LIKEWISE, OUTPUT CHARACTERS GO TO
   THE ARRAY LSTLIN, AND CURSRO POINTS TO THAT. STRINGS ARE PROCESSED
   FROM  CORE  RATHER  THAN DIRECTLY FROM THE FILE BECAUSE IT IS MORE
   FLEXIBLE TO DO IT THIS WAY...

      TWO  SCANNER FUNCTIONS ARE PROVIDED: SCAN A NUMBER, AND SCAN AN
   IDENTIFER.  EACH  OF  THESE  ROUTINES  EXPECTS THE CURRENTLY INPUT
   CHARACTER  (POINTED TO BY CURSRI) TO BE THE FIRST CHARACTER OF THE
   STRING,  AND  EACH LEAVES CURSRI POINTING TO THE LAST CHARACTER OF
   THE  IDENTIFIER  OR  NUMBER  (SO  AN  ILDB  WILL  FETCH  THE BREAK
   CHARACTER). BOTH SCANNERS WILL SKIP ANY LEADING SPACE.

      TWO  PRINT ROUTINES ARE ALSO PROVIDED: PRINT AN IDENTIFIER, AND
   PRINT  A  NUMBER.  THE  PRINT  A  NUMBER  ROUTINE IS A GENERALIZED
   PRINTER  THAT  WILL PRINT A NUMBER IN ANY BASE, WITH ANY NUMBER OF
   PLACES  AND  USING  ANY CHARACTER FOR FILL. SEVERAL OTHER ROUTINES
   ARE  THEN  IMPLIMENTED  TO  PROVIDE  SPECIAL  CASE  CALLS  TO THIS
   ROUTINE.

      SEVERAL MISC. ROUTINES ARE ALSO PROVIDES TO PRINT SPACES, TABS,
   STRINGS, AND CLEAR THE OUTPUT LINE...



   CHARACTER HANDLING ROUTINES...
	ILDB	-- RETURN THE NEXT CHARACTER FROM THE INPUT STRING
	IDPB	-- OUTPUT A CHARACTER TO THE OUTPUT STRING
	LDB	-- RETURN THE CURRENT CHARACTER FORM THE INPUT STRING
	ADJBP	-- ADJUST THE INPUT POINTER FORWARDS OR BACKWARDS

   STRING SCANNERS...
	SCNR50	-- SCAN A 10 CHARACTER ALPHA-NUMERIC IDENTIFIER
	SCNNUM	-- SCAN AN OCTAL OR DECIMAL NUMBER

   STRING PRINTERS...
	PRTDEC	-- PRINT DECIMAL WITH NO LEADING ZEROS OR SPACES
	PRTDEN	-- PRINT DECIMAL NUMBER OF N DIGITS W/ LEADING SPACES
	PRTOCT	-- PRINT OCTAL     "      "     "          "     "
	PRTR50	-- PRINT AN IDENTIFIER (10 CHARACTERS, W/ TRIALING SPACES)

   MISC. UTILITIES...
	SPACES	-- PRINT N SPACES
	PRTSTR	-- PRINT (COPY) A TYPE CHAR STRING
	PRTTAB	-- ADVANCE TO THE SPECIFIED TAB STOP
	CLRLST	-- CLEAR OUT THE OUTPUT (LIST) LINE
*)




(*
      THIS FUNCTION RETURNS THE NEXT CHARACTER FROM THE INPUT STRING
*)
FUNCTION  ILDB : CHAR;
BEGIN
  CURSRI := CURSRI + 1;
  ILDB := SRCLIN[CURSRI]
END;




(*
      THIS ROUTINE RETURNS THE NEXT NON-SPACE CHARACTER...
*)
FUNCTION  NEXT_CHAR : CHAR;
VAR   CH : CHAR;
BEGIN
  CH := ILDB;   IF  CH = ' '  THEN   CH := ILDB;
  NEXT_CHAR := CH
END;




(*
      THIS  FUNCTION  RETURNS  THE  CURRENT  CHARACTER FROM THE INPUT
   STRING
*)
FUNCTION  LDB : CHAR;
BEGIN
  LDB := SRCLIN[CURSRI]
END;




(*
      THIS PROCEDURE PUTS THE GIVEN CHARACTER IN THE OUTPUT STRING
*)
PROCEDURE  IDPB(CH : CHAR);
BEGIN
  CURSRO := CURSRO + 1;
  LSTLIN[CURSRO] := CH
END;




(*
      THIS  PROCEDURE  ADJUSTS  THE INPUT POINTER FORWARD OR BACKWARD
   THE SPECIFIED NUMBER OF CHARACTERS...
*)
PROCEDURE  ADJBP (N : INTEGER);
BEGIN
  IF  CURSRI+N <= 0  THEN   CURSRI := 1
    ELSE   IF  CURSRI+N > SRCLIN_LEN  THEN   CURSRI := SRCLIN_LEN
      ELSE   CURSRI := CURSRI + N
END;




(*
      THIS  PROCEDURE  SCANS AN IDENTIFIER. AN IDENTIFIER CONSISTS OF
   10  OR  MORE  ALPHA-NUMEROC  CHARACTERS,  BUT ALL AFTER CHARACTERS
   AFTER  THE  FIRST  10  WILL  BE  IGNORED. THE FUNCTION RETURNS THE
   IDENTIFIER AS ITS VALUE. ALSO, SCNR50 WILL IGNORE A LEADING SPACE,
   AND  LEAVE THE INPUT STRING POINTER AT THE LAST LEGAL CHARACTER OF
   THE STRING (THE ONE BEFORE THE BREAK CHARACTER).
*)
PROCEDURE  SCNR50 (VAR  SYMSTR : IDENTIFIER);
VAR   K : PINTEGER;   CH : CHAR;
BEGIN
  SYMSTR := BLANK_ID;
  K := 1;
  CH := LDB;   IF  CH = ' '  THEN   CH := ILDB;
  WHILE  (CH IN IDENT_CHARS)  OR  (CH = '.')  DO
    BEGIN
      IF  K <= IDENT_LEN  THEN
        BEGIN   SYMSTR[K] := CH;   K := K + 1   END;
      CH := ILDB
    END;
  ADJBP(-1)
END;




(* 
      THIS  ROUTINE  SCANS  A NUMBER FROM THE INPUT LINE. THIS NUMBER
   MAY  BE  IN EITHER THE DECIMAL OR OCTAL RADIXES, AS INDICATED BY A
   '.'  OR  'D'  SUFFIX FOR DECIMAL, OR 'B' FOR OCTAL. IF NO RADIX IS
   INDICATED,  THEN THE OCTAL RADIX WILL BE USED. THE SUFFIXES CAN BE
   HANDLED   WITHOUT  HAVING  TO  BACK  UP  THE  SCANNER  (ALWAYS  AN
   INEFFICIENT  PROCESS)  IF  WE  KEEP  TWO  SEPERATE  TALLYS, ONE IN
   DECIMAL  AND  ONE IN OCTAL, AND THEN DECIDE WHICH TO USE AFTER THE
   NUMBER  IS  SCANNED.  THIS IS A BOOLEAN PROCEDURE THAT WILL RETURN
   TRUE  IF THE NUMBER IS ILLEGAL FOR SOME REASON (I.E. '8' OR '9' IN
   OCTAL  NUMBER,  NULL STRING, ETC...) THE PARAMETER WILL RETURN THE
   INTEGER VALUE OF THE NUMBER...
*)
FUNCTION  SCNNUM (VAR   VAL : PDP_WORD) : BOOLEAN;
VAR   ERROR, NULL, NOTOCTAL  :  BOOLEAN;   OCTVAL, DECVAL  :  PDP_WORD;   CH : CHAR;
BEGIN

  (* INITIALIZE EVERYTHING... *)
  NULL := TRUE;   NOTOCTAL := FALSE;   ERROR := FALSE;
  OCTVAL := 0;   DECVAL := 0;   VAL := 0;
  CH := LDB;   IF  CH = ' '  THEN   CH := ILDB;

  (* SCAN ALL THE DIGITS IN THE NUMBER...*)
  WHILE  CH IN ['0'..'9']  DO
    BEGIN
      DECVAL := DECVAL * 10  +  ORD(CH) - ORD('0');
      OCTVAL := OCTVAL * 8   +  ORD(CH) - ORD('0');
      IF  CH IN ['8', '9']  THEN   NOTOCTAL := TRUE;
      CH := ILDB;   NULL := FALSE
    END;

  (* IS THERE A RADIX SUFFIX ?? *)
  IF  (CH IN ['D', '.', 'B'])  AND  (NOT NULL)  
    THEN   BEGIN
      IF  CH = 'B'
        THEN   IF  NOTOCTAL  THEN   ERROR := TRUE   ELSE   VAL := OCTVAL
        ELSE   VAL := DECVAL;
      ADJBP(+1)
    END
    ELSE
      IF  NOTOCTAL   THEN  VAL := DECVAL   ELSE  VAL := OCTVAL;

  (* IS THIS A LEGAL NUMBER ?? *)
  IF  VAL > MAXIMUM_NUMBER  THEN
    BEGIN   ERROR := TRUE;   VAL := VAL MOD (MAXIMUM_NUMBER+1)   END;
  IF  NULL  THEN   ERROR := TRUE;
  IF  ERROR  THEN   CERR(ER_IFN);

  (* CORRECT THE POINTER AND RETURN THE VALUE *)
  ADJBP(-1);
  SCNNUM := ERROR

END;




(*
       THIS  ROUTINE  IS USED TO OUTPUT A SINGLE DIGIT; NOTE THAT THIS
    IS  IMPORTANT  SINE  IT WILL SUBSTITUTE LETTERS FOR DIGITS GREATER
    THAN 9 (THIS IS NECESSARY SO WE CAN OUTPUT HEX NUMBERS...)
*)
PROCEDURE DIGITOUT (N : PINTEGER);
BEGIN
  IF N >= 10
    THEN   IDPB( CHR( N-10 + ORD('A') ) )
    ELSE   IDPB( CHR( N + ORD('0') ) )
END;




(*
      THIS  ROUTINE  PRINTS  A  NUMBER IN ANY RADIX, WITH A SPECIFIED
   NUMBER  OF PLACES, AND USING ANY CHARACTER AS LEADING FILL. IF THE
   NUMBER REQUIRES MORE THAN THE SPECIFIED NUMBER OF PLACES, THEN THE
   ENTIRE  NUMBER WILL ALWAYS BE PRINTED. NOTE THAT THIS ROUTINE WILL
   NOT  CORRECTLY  HANDLE  NEGATIVE  NUMBERS. THIS FUNCTION IS EASILY
   ACCOMPLISHED BY USING RECURSION IN PASCAL...
*)
PROCEDURE  NUMOUT (RADIX, NUMBER, PLACES  : PINTEGER;   FILL : CHAR);
VAR   K, N : INTEGER;
BEGIN
  N := NUMBER MOD RADIX;
  IF  (NUMBER DIV RADIX) = 0
    THEN   BEGIN
      IF  PLACES > 1  THEN   FOR   K := PLACES-1  DOWNTO  1   DO  IDPB(FILL);
      DIGITOUT (N)
    END
    ELSE   BEGIN
      NUMOUT (RADIX, (NUMBER DIV RADIX), (PLACES - 1), FILL);
      DIGITOUT (N)
    END
END;




(*
      THIS  ROUTINE PRINTS A DECIMAL NUMBER WITH NO LEADING SPACES OR
   ZEROS...
*)
PROCEDURE  PRTDEC (NUMBER : PINTEGER);
BEGIN   NUMOUT(10, NUMBER, 0, '0')   END;




(*
      THIS ROUTINE PRINTS A DECIMAL NUMBER OF THE SPECIFIED NUMBER OF
   PLACES, WITH LEADING SPACES.
*)
PROCEDURE  PRTDEN(NUMBER, PLACES  :  PINTEGER);
BEGIN   NUMOUT(10, NUMBER, PLACES, ' ')   END;




(*
      THIS  PROCEDURE  PRINTS A OCTAL  NUMBER OF THE SPECIFIED NUMBER
   OF PLACES, WITH LEADING ZEROS...
*)
PROCEDURE  PRTOCT(NUMBER, PLACES  :  PINTEGER);
BEGIN   NUMOUT(8, NUMBER, PLACES, '0')   END;




(*
      THIS  ROUTINE  PRINTS  AN  IDENTIFIER.  THIS  ALWAYS  TAKES  10
   CHARACTERS, AND IS PADDED WITH TRAILING SPACES, IF NECESSARY...
*)
PROCEDURE  PRTR50;
VAR   K : IDENT_INDEX;
BEGIN
  FOR   K := 1  TO IDENT_LEN   DO   IDPB(SYMSTR[K])
END;




(*
      THIS  ROUTINE COPIES A TYPE CHAR STRING OF THE SPECIFIED LENGTH
   INTO THE OUTPUT STRING...
*)
PROCEDURE  PRTSTR(STR : SRCLIN_STRING);
VAR   K, LEN : INTEGER;
BEGIN
  LEN := SRCLIN_LEN;
  WHILE (STR[LEN] = ' ') AND (LEN > 1) DO LEN := LEN - 1;
  FOR   K := 1  TO  LEN   DO
    IF (STR[K] <> CH_NUL) AND (STR[K] <> CH_FFD)  THEN   IDPB(STR[K])
END;




(* 
      THIS ROUTINE SKIPS THE SPECIFIED NUMBER OF SPACES IN THE OUTPUT
   STRING.  IF  THIS  NUMBER  IS NEGATIVE OR ZERO, THEN NO SPACES ARE
   SKIPPED...
*)
PROCEDURE  SPACES;
VAR   K : INTEGER;
BEGIN
  IF  NUMBER <> 0  THEN
    FOR   K := 1  TO  NUMBER   DO   IDPB(' ')
END;




(*
      THIS  ROUTINE  SKIPS  TO THE SPECIFIED TAB STOP (COLUMN) IN THE
   OUTPUT STRING...
*)
PROCEDURE  PRTTAB(TAB : PINTEGER);
BEGIN   SPACES( (TAB - CURSRO - 1) )   END;




(*
      THIS  ROUTINE  CLEARS THE OUTPUT LINE AND RESETS THE POINTER TO
   THE BEGINNING...
*)
PROCEDURE  CLRLST;
VAR   K : INTEGER;
BEGIN
  CURSRO := 0;
  FOR   K := 1  TO  LSTLIN_LEN   DO   LSTLIN[K] := ' '
END;








(*
	***** E R R O R   P R O C E S S I N G *****

      THIS  MODULE  PROVIDES  ROUTINES TO PROCESS ALL THE ERRORS THAT
   ARE  ENCOUNTERED  IN  THE  ASSEMBLY...  THIS INCLUDES BOTH RUNTIME
   ERRORS (I.E SYMBOL TABLE FULL), AND ASSEMBLY ERRORS (ERRORS IN THE
   USER'S INPUT PROGRAM).

      RUNTIME  ERRORS  ARE PROCESSED BY PRINTING THE ASSOCIATED ERROR
   MESSAGE  ON THE TERMINAL, AND THEN EXITING. NOTE THAT SINCE PASCAL
   DOSEN'T PROVIDE US WITH ANY TO GET OUT OF A PROGRAM IN THE MIDDLE,
   THE  EXIT  FROM THIS ASSEMBLER MUST BE DONE BY USING A GOTO TO THE
   LAST  END  IN  THE  MAIN PROGRAM. THIS IS PASCAL'S LIMITATION, NOT
   MINE, AND IS A PERFECTLY VALID USE OF THE GOTO.

      ASSEMBLY  ERRORS  ARE IMPLEMENTED IN THE TRADITIONAL MANNER FOR
   ASSEMBLERS (OR AT LEAST NON-IBM ASSEMBLERS): A SINGLE LETTER ERROR
   CODE  IS  PRINTED  IN THE LISTING AT THE START OF EVERY LINE WHICH
   CONTAINS  AN  ERROR.  THE  ERROR CODES ARE ACCUMULATED IN A 26 BIT
   LOGICAL ARRAY UNTIL THE THIS STATEMENT IS ASSEMBLED, AND THEN THEY
   ARE  PRINTED  INTO  THE  LISTING.  NOTE THAT ERRORS ARE IGNORED ON
   PASS1,  AS  THERE  IS  NO LIST FILE YET (THE SAME ERROR WILL OCCUR
   UNDER PASS2 ANYWAY...).


   THE FOLLOWING ROUTINES ARE PROVIDED...
	ERRMSG	-- PRINT RUNTIME ERROR AND EXIT
	CERR	-- FLAG ASSEMBLY ERROR FOR THIS STATEMENT
	ERRCHR	-- PUT THE ERROR CHARACTERS INTO THE LIST FILE
*)




(*
      THIS ROUTINE PRINTS A FATAL ERROR MESSAGE AND EXITS; IT HAS ONE
   ARGUMENT:  THE  STRING OF THE ERROR MESSAGE TEXT. **NOTE THAT 9999
   IS THE TAG ON THE LAST END IN THE MAIN PROGRAM...**
*)
PROCEDURE ERRMSG;
BEGIN
  WRITELN(ERRSTR);
  GOTO 9999  (* EXIT *)
END;




(*
      THIS  ROUTINE  ADDS AN ASSEMBLY ERROR TO THE LIST OF ERRORS FOR
   THIS  STATEMENT.  IT  IS  CALLED WITH THE CHAR VALUE OF THE LETTER
   DESIRED. NOTE THAT THIS MUST BE A LETTER (A..Z).
*)
PROCEDURE CERR;
BEGIN
  (* ONLY COUNT ERRORS UNDER PASS 2... *)
  IF PASS_2 THEN
    BEGIN
      ERRCOD[  ORD(ERRCHR) - ORD('A')  ]  := TRUE;
      ERRORK := ERRORK + 1;
      FL_ERR := TRUE
    END
END;




(*
      THIS ROUTINE OUTPUTS ALL THE ERROR LETTERS ACCUMULATED BY CERR.
   AND,  AS  A  SIDE EFFECT IT WILL RESET THE ERROR LIST FOR THE NEXT
   PASS...
*)
PROCEDURE ERRCHR;
VAR   K : INTEGER;
BEGIN
  IF FL_ERR THEN
    FOR   K := 0  TO  25   DO
      BEGIN
        IF ERRCOD[K] THEN  IDPB( CHR(K + ORD('A')) );
        ERRCOD[K] := FALSE
      END
END;








(*
	***** F I L E   O P E R A T I O N S *****

      THESE  ROUTINES  PROVIDE ALL THE FILE OPERATIONS NEEDED FOR THE
   ASSEMBLER.  THIS  INCLUDES ROUTINES TO READ AND EDIT SOURCE LINES,
   BUILD LIST LINES, AND OUTPUT CODE TO THE OBJECT FILE.

      SOURCE FILES ARE ALWAYS READ AS A FILE OF CHAR; THIS MEANS THAT
   IT IS NOT POSSIBLE TO INCLUDE TABS, LOWER CASE, FORM FEEDS, OR ANY
   OTHER  USEFUL  CHARACTERS  IN  THE  SOURCE  PROGRAM (UNFORTUNATELY
   STANDARD  PASCAL  PROVIDES NO BETTER WAY...). IN GENERAL, IT TAKES
   THREE  ROUTINES TO READ A SOURCE LINE: (1) SRCGLN, WHICH READS THE
   TEXT  OF  THE  NEXT  LINE  INTO  THE ARRAY SRCLNU; (2) EDIT, WHICH
   CONVERTS  THE  LINE  INTO  A  MORE  STANDARD  FORMAT  (I.E. REMOVE
   COMMENTS,  MULTIPLE  SPACES  TO ONE, ETC...); AND LINE, WHICH WILL
   CALL  STEPS (1) AMD (2), AND THEN REMOVE ALL BLANK OR COMMENT ONLY
   LINES.  THUS  THE  ASSEMBLER ALWAYS CALLS ROUTINE LINE TO READ THE
   NEXT  SOURCE  LINE,  AS THIS GUARANTEES THAT THE LINE READ WILL BE
   NON-BLANK, AND NON-COMMANT ONLY.

      THE  LIST  FILE  IS  ALSO  PROCESSED  IN TYPE CHAR. THE PRIMARY
   ROUTINE  OF  IMPORTANCE HERE IS LIST, WHICH GENERATES THE COMPLETE
   LIST  LINE  WHEN  GIVEN  A  FLAG INDICATING THE TYPE OF LINE TO BE
   LISTED.  THE  ROUTINE  LSTSYM  WILL DUMP OUT THE SYMBOL TABLE, AND
   LISTLN WILL LIST A SINGLE LINE, PRINTING A NEW PAGE IF NECESSARY.

     THE  OBJECT  FILE  IS HANDLED BY A SINGLE ROUTINE, WHICH OUTPUTS
   THE  ADDRESS  AND  THE  GENERATED CODE IN THE CORRECT FORMAT. NOTE
   THAT THE OBJECT FILE IS A FILE OF CHAR.



   LIST FILE ROUTINES...
	HEADER	-- START A NEW PAGE IN THE LISTING
	LISTLN	-- LIST OUTPUT LINE, WITH HEADER IF NECESSARY
	LIST	-- LIST A COMPLETE LINE OF CODE AND TEXT
	LSTSYM	-- LIST OUT THE USER SYMBOL TABLE

   SOURCE FILE ROUTINES...
	SRCGLN	-- READ NEXT LINE VERBATUM INTO SRCLNU
	EDIT	-- CLEAN UP THE SYNTAX OF THE LINE
	LINE	-- READ THE NEXT COMPLETE, NON-COMMENT LINE

   OBJECT FILE ROUTINES...
	OBJECT	-- OUTPUT CODE AND ADDRESS TO OBJECT FILE
*)




(*
      THIS ROUTINE STARTS A NEW PAGE IN THE LIST FILE, AND PRINTS THE
   HEADER FOR IT.
*)
PROCEDURE HEADER;
VAR   K : PINTEGER;
BEGIN

  (* START A NEW PAGE.. *)
  PAGE(LISTFILE);   WRITELN(LISTFILE);

  (* AND SET UP THE TITLE STRING AND PAGE COUNTER FOR PRINTING... *)
  PAGEK := PAGEK + 1;
  WRITE (LISTFILE, TITLE_STRING);
  WRITE (LISTFILE, ' ':40, 'PAGE :', PAGEK:3);
  WRITELN (LISTFILE);

  (* PRINT THE SECOND LINE WITH THE FILE NAME AND PROGRAM TITLE... *)
  FOR   K := 1  TO  SRCLIN_LEN   DO  WRITE (LISTFILE, PROGRAM_TITLE[K]);
  WRITELN (LISTFILE);

  (* AND FINALLY LEAVE TWO BLANK LINES... *)
  WRITELN (LISTFILE);   WRITELN (LISTFILE);

  (* FINALLY RESET THE LINE/PAGE COUNTER *)
  LINPAK := LN_PAGE

END;




(*
      THIS ROUTINE OUTPUTS THE CURRENT LIST LINE TO THE LIST FILE. IT
   WILL  START  A  NEW  PAGE IF NECESSARY. NOTE THAT THE LIST LINE IS
   ALWAYS  BUILT  IN  THE  ARRAY LSTLIN BY ALL THE OUTPUT ROUTINES...
*)
PROCEDURE LISTLN;
VAR LEN: INTEGER;
BEGIN

  (* DO WE NEED TO START A NEW PAGE ?? *)
  LINPAK := LINPAK - 1;
  IF (LINPAK = 0)  OR  (FL_PAGE)  THEN   HEADER;
  FL_PAGE := FALSE;

  (* TRIM TRAILING SPACES FROM THE LINE *)
  LEN := LSTLIN_LEN;
  WHILE (LSTLIN[LEN] = ' ') AND (LEN > 1) DO LEN := LEN - 1;

  (* NOW OUTPUT THE TEXT OF THE LINE... *)
  WRITELN (LISTFILE, LSTLIN:LEN)

END;




(*
      THIS  ROUTINE  IS  TE HEART OF ALL THE LIST FILE PROCESSING. IT
   WILL  GENERATE A COMPLETE LINE TO BE LISTED, FROM THE SOURCE TEXT,
   AND  THE GENERATED CODE AND ADDRESS. THIS LIST LINE COMTAINS (FROM
   LEFT  TO  RIGHT):  A  LINE  NUMBER,  ANY  ERROR  LETTERS  FOR THIS
   STATEMENT,  THE  ADDRESS (IF NEEDED) AND THE CODE (IF NEEDED), AND
   THEN  THE  TEXT  OF  THE  SOURCE  STATEMENT.  SINCE  THE ASSEMBLER
   ACTUALLY  REQUIRES  A  FEW SLIGHTLY DIFFERENT FORMATS FOR ITS LIST
   LINES,  THE  ROUTINE  LIST  IS  CONTROLLED  BY THE FOLLOWING FLAGS
   (PASSED AS THE PARAMETER):

	LF_LBL	-- LIST A BLANK LINE (NO CODE, ADDRESS, ERRORS, OR TEXT)
	LF_LAD	-- LIST ADDRESS FIELD ONLY (NO GENERATED CODE)
	LF_LAC	-- LIST ADDRESS AND CODE (NORMAL LISTING)
	LF_LCD  -- LIST ONLY THE GENERATED CODE AND TEXT
	LF_LNT  -- LIST THE PC AND CODE, BUT NO TEXT
	LF_LTX	-- LIST ONLY THE STATEMENT TEXT  (FOR COMMENT ONLY LINES)

*)
PROCEDURE LIST (CODE : PDP_WORD;  LIST_TYPE: PINTEGER);
BEGIN

  (* SET UP THE LIST LINE AND THE LINE NUMBER... *)
  CLRLST;
  LINEK := LINEK + 1;   PRTDEN (LINEK, 4);

  (* QUIT NOW IF HE ONLY WANTS A BLANK LINE... *)
  IF  (LIST_TYPE <> LF_LBL)  THEN
    BEGIN

      (* INCLUDE THE ERROR CHARACTERS... *)
      ERRCHR;   PRTTAB(9);

      (* DO WE NEED THE ADDRESS FIELD ?? *)
      IF  LIST_TYPE  IN  [LF_LAD, LF_LAC, LF_LNT]
        THEN  PRTOCT(PC, ADDRESS_LEN)    ELSE  SPACES (ADDRESS_LEN);
      SPACES (4);

      (* DO WE NEED TO PRINT THE CODE ?? *)
      IF  LIST_TYPE IN [LF_LAC, LF_LCD, LF_LNT]
        THEN   PRTOCT (CODE, CODE_LEN)   ELSE   SPACES (CODE_LEN);
      SPACES (5)

    END;

  (* SHOULD WE INCLUDE THE SOURCE TEXT ?? *)
  IF  (LIST_TYPE <> LF_LBL)  AND  (LIST_TYPE <> LF_LNT)
    THEN   PRTSTR (SRCLNU);

  (* PRINT OUT WHAT WE'VE GOT SO FAR... *)
  LISTLN;   IF FL_ERR THEN WRITELN (LSTLIN);

END;




(*
      THIS  ROUTINE  PRINTS  OUT  THE  CONTENTS  OF THE USER'S SYMBOL
   TABLE.  IT  PRINTS FOUR SYMBOLS PER LINE, EACH ONE FOLLOWED BY ITS
   VALUE AND ANY ERROR FLAGS THAT MIGHT BE SET. NOTE THAT THE SYMBOLS
   ARE  PRINTED  IN THE ORDER THAT THEY APPEAR IN THE HASH TABLE, AND
   THUS WILL NOT BE IN ANY PARTICULAR ORDER. IDEALLY THE TABLE SHOULD
   BE  SORTED  BEFORE  PRINTING THE SYMBOL TABLE, BUT THAT'S TOO MUCH
   TROUBLE FOR THIS ASSIGNMENT...
*)
PROCEDURE  LSTSYM;
VAR   K, K1 : INTEGER;
BEGIN

  (* START EVERYTHING OUT ON A NEW PAGE... *)
  PROGRAM_TITLE := SYMMSG;   HEADER;   CLRLST;   K1 := 0;

  (* LOOP THROUGH ALL THE SYMBOLS IN THE TABLE.. *)
  FOR   K := 0  TO  SYMTAB_LEN   DO
    BEGIN
      
      (* MAKE SURE THAT THERE'S REALLY A SYMBOL HERE *)
      IF  SYMTAB[K].NAME <> BLANK_ID   THEN
        BEGIN

          (* PRINT THE SYMBOL NAME AND VALUE... *)
          PRTR50 (SYMTAB[K].NAME);   SPACES (1);
          PRTOCT (SYMTAB[K].VAL, ADDRESS_LEN);

          (* ARE THERE ANY ERROR FLAGS SET ?? *)
          IF  SYMTAB[K].SF_UDF  THEN   IDPB ('U')
            ELSE   IF  SYMTAB[K].SF_MDF  THEN   IDPB ('M')
              ELSE   IDPB (' ');

          K1 := K1 + 1;   SPACES (10)
        END;

      (* DO WE NEED TO START ANOTHER LINE ?? *)
      IF  (K1 >= 5)  OR  ( (K >= SYMTAB_LEN) AND (K1 <> 0) )  THEN
        BEGIN   LISTLN;   CLRLST;   K1 := 0   END

    END

END;




(*
      THIS  ROUTINE  READS THE NEXT SOURCE LINE FROM THE SOURCE FILE.
   IT IS READ VERBATUM (EXCEPT FOR THE <CRLF> AT THE END.). THIS TEXT
   IS  THEN COPIED INTO THE ARRAY SRCLNU. THIS FUNCTION RETURNS FALSE
   IF  THERE  ARE  NO  MORE  LINES  IN THE SOURCE FILE (I.E. IT IS AT
   EOF...).
*)
FUNCTION  SRCGLN : BOOLEAN;
BEGIN

  (* IS THERE ANYTHING LEFT IN THE SOURCE FILE ?? *)
  IF   EOF(SOURCEFILE)

    (* NO -- RETURN FALSE AND QUIT *)
    THEN  SRCGLN := FALSE

    (* YES -- READ ONE LINE *)
    ELSE   BEGIN
      READLN(SOURCEFILE, SRCLNU);
      SRCGLN := TRUE
    END

END;




(*
      THIS  ROUTINE  IS USED TO 'EDIT' THE SOURCE LINE. THIS MAKES IT
   MUCH SIMPLER TO SCAN THE SOURCE CODE, AND PERMITS MORE FLEXIBILITY
   IN  THE  INPUT  TO THIS ASSEMBLER. THE EDITING FUNCTIONS PERFORMED
   INCLUDE:

	1 -- CONVERT MULTIPLE SPACES TO A SINGLE ONE
	2 -- REMOVE ANY COMMENT FROM THE LINE
	3 -- REMOVE ALL TRAILING SPACES, AND
	4 -- INSERT THE END OF LINE MARKER (CH_EOL) AT THE END OF THE LINE...

      THE  ORIGINAL SOURCE TEXT (AS READ FROM THE FILE) IS IN SRCLNU,
   AND THIS ROUTINE PUTS THE OUTPUT TEXT INTO THE ARRAY SRCLIN.
*)
PROCEDURE  EDIT;
VAR   K, K1 : INTEGER;   CH, LAST : CHAR;   IN_COMMENT : BOOLEAN;
BEGIN

  (* RESET THE EDIT LINE TO BLANKS... *)
  SRCLIN := BLANK_LINE;

  LAST := CH_EOL;   K1 := 1;   IN_COMMENT := FALSE;

  (* COPY THE LINE FROM ONE ARRAY TO THE OTHER, CONVERTING AS WE GO *)
  FOR   K := 1  TO  SRCLIN_LEN   DO
    BEGIN

      (* CONVERT TABS AND FORM-FEEDS TO BLANKS.... *)
      CH := SRCLNU[K];
      IF (CH = CH_TAB) OR (CH = CH_FFD) THEN  CH := ' ';

      (* IS THIS THE START OF A COMMENT ?? *)
      IF  CH = CH_COM  THEN   IN_COMMENT := TRUE;

      (* SUPPRESS MULTIPLE SPACES... *)
      IF  (CH = ' ')  AND  (LAST = ' ')  THEN   CH := CH_EOL;

      (* AND PUT THIS CHARACTER IN THE OUTPUT LINE... *)
      IF  (CH <> CH_EOL)  AND  (NOT(IN_COMMENT))  THEN
        BEGIN   SRCLIN[K1] := CH;   K1 := K1 + 1;   LAST := CH   END

    END;

  (* INSERT THE EOL CHARACTER, AND TRIM ANY TRAILING SPACES... *)
  IF  LAST = ' '
    THEN   SRCLIN[K1-1] := CH_EOL
    ELSE   SRCLIN[K1  ] := CH_EOL

END;




(*
      THIS ROUTINE READS A COMPLETE LINE FROM THE SOURCE FILE. IF THE
   LINE  IS BLANK, OR CONTAINS ONLY A COMMENT, THEN IT WILL BE COPIED
   TO THE LIST FILE DIRECTLY. THUS THIS ROUTINE WILL CONTINUE TO READ
   LINES  UNTIL  IT  GETS  ONE THAT CONTAINS VAILD CODE TO PROCESS...
   THIS ROUTINE WILL RETURN TRUE IF THE LINE WAS READ, OR FALSE IF AN
   EOF WAS FOUND...
*)
FUNCTION  LINE : BOOLEAN;
VAR   DONE : BOOLEAN;   CH : CHAR;
BEGIN

  DONE := FALSE;   LINE := TRUE;

  (* LOOP UNTIL WE GET A REAL LINE... *)
  REPEAT

    (* TRY TO READ ANOTHER LINE *)
    IF NOT (SRCGLN)

      (* NONE THERE -- GIVE THE EOF RETURN *)
      THEN   BEGIN   DONE := TRUE;   LINE := FALSE   END

      (* GOT ONE -- DOES IT HAVE ANYTHING WORTH SEEING ? *)
      ELSE   BEGIN
        EDIT;  (* CLEAN UP THE LINE... *)
        IF  SRCLIN[1] = ' '   THEN  CH := SRCLIN[2]   ELSE  CH := SRCLIN[1];
        IF  (CH = CH_EOL)  OR  (CH = CH_COM)
          THEN   BEGIN   IF  PASS_2  THEN  LIST (NULL_CODE, LF_LTX)   END
          ELSE   DONE := TRUE
      END

  UNTIL DONE;

  (* AND RESET THE LINE POINTER TO THE START... *)
  CURSRI := 0

END;



(* THIS PROCEDURE OUTPUTS ANOTHER CHARACTER TO THE OBJECT FILE... *)
PROCEDURE PUTOBJECT (N : INTEGER);
  PROCEDURE P8 (N, K: INTEGER);
  BEGIN
    IF K > 1 THEN P8(N DIV 8, K-1);
    WRITE(OBJECTFILE, CHR((N MOD 8)+ORD('0')))
  END;
BEGIN
  P8(N, 3);  WRITELN(OBJECTFILE);
  CHECKSUM := CHECKSUM + N;
END;




(*
       THIS  PROCEDURE  OUTPUTS A RECORD TO THE OBJECT FILE; THIS FILE
    IS  IN  THE  DEC  STANDARD PDP-8 RIM FORMAT; DOCUMENTATION OF THIS
    TYPE OF OUTPUT MAY BE FOUND IN ANY DEC PDP-8 MANUAL....
*)
PROCEDURE  OBJECT (ADDRESS : PDP_WORD;  CODE : PDP_WORD);

BEGIN

  (* DO WE NEED TO OUTPUT A NEW ORIGIN ???? *)
  IF  ADDRESS <> (LAST_ADDR+1)
    THEN   BEGIN
      PUTOBJECT ( (ADDRESS DIV 64 {100B} ) + 64 {100B} );
      PUTOBJECT (ADDRESS MOD 64 {100B})
    END;
  LAST_ADDR := ADDRESS;

  (* AND THEN OUTPUT THE CODE RECORDS... *)
  PUTOBJECT (CODE DIV 64 {100B});
  PUTOBJECT (CODE MOD 64 {100B})

END;



(*
      THIS ROUTINE WILL PUNCH THE CHECKSUM INTO THE OBJECT FILE...
*)
PROCEDURE PUNCHSUM;
VAR C : INTEGER;
BEGIN
  C := CHECKSUM MOD (MAXIMUM_NUMBER+1);
  PUTOBJECT (C DIV 64 {100B});
  PUTOBJECT (C MOD 64 {100B});
END;








(*
	***** E X P R E S S I O N   S C A N N E R *****

       THESE  ROUTINES  ARE USED TO SCAN ARITHMETIC EXPRESSIONS IN THE
    SOURCE  CODE. THIS IS PRIMARILY FOR CALCULATING ADDRESS CONSTANTS,
    BUT  MAY  ALSO  BE USED FOR THE QRG AND EQU PSEDUO-OPS, AND ETC...
    NORMALLY THE EXPRESSION EVALUATOR IS USED ONLY ON THE SECOND PASS,
    BUT  FOR  SOME  PSEUDO-OPS (EQU, ORG,...) IT IS ALSO CALLED ON THE
    FIRST PASS. IF THE EVALUATOR DETECTS AN UNDEFINED SYMBOL, THEN THE
    SYMBOL  WILL  BE  DEFINED  WITH  THE SF_UDF ERROR FLAG SET. IF THE
    SCANNER  DETECTS  ANY  OTHER  ERROR  (SUCH  AS  A  BAD  NUMBER,  A
    PREVIOUSLY  UNDEFINED  OR MULTIPLY DEFINED SYMBOL, ETC). THEN CERR
    WILL  BE  CALLED  TO  INCLUDE  TO  APPROPRIATE  ERROR  CODE IN THE
    LISTING. OTHERWISE THE EXPRESSION SCANNER WILL RETURN THE VALUE OF
    THE EXPRESSION SCANNED.
*)




(*
      THIS  ROUTINE  RETURNS  THE VALUE OF A USER DEFINED SYMBOL (THE
   SYMBOL  HAS  ALREADY BEEN SCANNED). IF THE SYMBOL CAN NOT BE FOUND
   IN  THE  USER DEFINED SYMBOL TABLE, THEN IT IS ENTERED AND FLAGGED
   AS  UNDEFINED.  IF IT IS FOUND, THEN ITS VALUE IS RETURNED. IN ANY
   CASE,  IF AN ERROR OCCURS THEN CERR IS CALLED TO NOTE THE ERROR IN
   THE  LISTING. THIS FUNCTION RETURNS FALSE IF THE WAS NO ERROR, AND
   TRUE IF AN ERROR OCCURED.
*)
FUNCTION  ARISYM (SYMBOL_NAME : IDENTIFIER;   VAR  VAL : PDP_WORD) : BOOLEAN;
VAR   INDEX : SYMTAB_INDEX;   NEW_SYMBOL : SYMTAB_ENTRY;   INDEX2 : OPTAB_INDEX;
BEGIN

  (* SEE IF THE SYMBOL IS IN THE SYMBOL TABLE... *)
  IF  VALSYM(SYMBOL_NAME, INDEX)

    (* IT'S FOUND, CHECK FOR ANY ERROR FLAGS AND GET THE VALUE... *)
    THEN   BEGIN
      IF  (SYMTAB[INDEX].SF_UDF)  OR  (SYMTAB[INDEX].SF_MDF)
        THEN   BEGIN   CERR(ER_SYM);   ARISYM := TRUE   END
        ELSE   ARISYM := FALSE;
      VAL := SYMTAB[INDEX].VAL;
      IF SYMTAB[INDEX].SF_OPD 
        THEN BEGIN ARISYM := MRI_EVAL (VAL);  ADJBP(-1)   END;
    END


    (* IT'S NOT A USER SYMBOL -- CHECK FOR AN OPCODE.. *)
    ELSE   IF  VALOP (SYMBOL_NAME, INDEX2)
      THEN   ARISYM := MACHOP (INDEX2, VAL)

        (* IT'S NOT FOUND -- MAKE IT UNDEFINED... *)
        ELSE   BEGIN
          NEW_SYMBOL.NAME := SYMBOL_NAME;
          NEW_SYMBOL.VAL := 0;
          NEW_SYMBOL.SF_MDF := FALSE;   NEW_SYMBOL.SF_UDF := TRUE;
          NEW_SYMBOL.SF_TAG := FALSE;   NEW_SYMBOL.SF_EQU := FALSE;
	  NEW_SYMBOL.SF_OPD := FALSE;
          DEFSYM (NEW_SYMBOL);
          CERR (ER_UDF);
          ARISYM := TRUE;   VAL := 0;
        END

END;




(*
       THIS ROUTINE IS CALLED WHENEVER A LITERAL IS FOUND IN THE INPUT
    LINE.  THIS  ROUTINE  WILL  ATTEMPT  TO  (1) SCAN THE VALUE OF THE
    LITERAL, (2) SEE IF THAT VALUE ALREADY EXISTS IN THE LITERAL TABLE
    (TO  COMPRESS LITERALS), AND (3) ENTER THE LITERAL IN THE TABLE IF
    NECESSARY...  REMEMBER  THAT  WE  MUST BE CAREFUL NOT TO ALLOW THE
    LITERAL TABLE TO OVERLAP CODE... (NOTE THAT IT IS POSSIBLE TO NEST
    LITERALS)
*)
FUNCTION LITERAL (VAR VAL : PDP_WORD) : BOOLEAN;
VAR   ERROR, FOUND : BOOLEAN;   N : PDP_WORD;   LOC : INTEGER;
BEGIN

  (* FIRST ATTEMPT THE SCAN THE CONTENTS OF THE LITERAL *)
  ERROR := FALSE;
  IF  SCNARI (N)
    THEN   BEGIN   ERROR := TRUE;   LOC := 0   END
    ELSE   IF  LDB <> CH_LTE
      THEN   BEGIN  ERROR := TRUE;   CERR(ER_SYN);  LOC := 0   END

      (* TRY TO SEE IF THE LITERAL IS ALREADY IN THE TABLE... *)
      ELSE   BEGIN
        LOC := LITERAL_BASE;   FOUND := FALSE;
        WHILE   ((LOC MOD PAGE_SIZE) <> 0)  AND  NOT (FOUND)  DO
          IF  N = LITERALS[LOC MOD PAGE_SIZE]
            THEN  FOUND := TRUE
            ELSE  LOC := LOC + 1;

        (* ENTER THIS LITERAL IN THE TABLE IF IT ISN'T ALREADY THERE *)
        IF  NOT (FOUND)
          THEN   IF  LITERAL_BASE <= PC+1
            THEN   BEGIN   ERROR := TRUE;   CERR(ER_PAF);   LOC := 0   END
            ELSE   BEGIN
              LITERAL_BASE := LITERAL_BASE - 1;   LOC := LITERAL_BASE;
              LITERALS[LOC MOD PAGE_SIZE] := N
            END
    END;

  (* RETURN THE ADDRESS OF THE LITERAL AS ITS VALUE... *)
  VAL := LOC;   LITERAL := ERROR

END;




(*
       THIS ROUTINE IS CALLED TO SCAN AN ASCII CONSTANT; THIS CONSTANT
    TAKES  THE  FORM OF '"X"', WHERE X IS ANY ASCII CHARACTER ENCLOSED
    IN  QUOTE  MARKS.  THE  VALUE  OF THIS CONSTANT IS, OF COURSE, THE
    ASCII CHARACTER CORRESPONDING TO X... THIS ROUTINE RETURNS TRUE IF
    A ERROR WAS DISCOVERED IN THE STRING, FALSE OTHERWISE...
*)
FUNCTION ASCIICON (VAR  VAL : PDP_WORD) : BOOLEAN;
VAR   CH : CHAR;
BEGIN

  CH := ILDB;
  IF  ILDB <> CH_QTE
    THEN   BEGIN  CERR(ER_SYN);   ASCIICON := TRUE   END
    ELSE   BEGIN  VAL := ORD(CH);   ASCIICON := FALSE   END
END;



(*
      THIS  ROUTINE  SCANS  ANY FORM OF OPERAND. IT EXAMINES THE NEXT
   NON-SPACE  CHARACTER;  IF IT IS A LETTER, THEN IT ATTEMPTS TO SCAN
   AND FIND THE VALUE OF A SYMBOL, OTHERWISE IF IT'S A NUMBER THEN IT
   RETURNS  THE VALUE OF THE NUMERIC STRING THAT FOLLOWS. ARI_OPERAND
   RETURNS  TRUE  IF  THERE WAS AN ERROR IN THE OPERAND; AND FALSE IF
   THERE  WAS  NOT...  NOTE  THAT  IF  AN ERROR OCCURS, A MESSAGE HAS
   ALREADY BEEN PRINTED VIA CERR...
*)
FUNCTION  ARI_OPERAND (VAR  VAL : PDP_WORD) : BOOLEAN;
VAR   CH : CHAR;   SYMBOL_NAME : IDENTIFIER;   NEGATIVE : BOOLEAN;
BEGIN

  (* GET THE NEXT NON-SPACE CHARACTER... *)
  NEGATIVE := FALSE;   CH := NEXT_CHAR;

  (* IS THIS A LEADING SIGN (+ OR -) ??? *)
  IF  CH = '+'
    THEN   CH := NEXT_CHAR
    ELSE   IF  CH = '-'
      THEN   BEGIN  NEGATIVE := TRUE;   CH := NEXT_CHAR   END;

  (* IS THIS A STAR (RETURN THE CURRENT LOCATION) ?? *)
  IF   (CH = CH_RPC)  OR  (CH = CH_RPO)
    THEN   BEGIN   VAL := PC;   ARI_OPERAND := FALSE   END

    (* OR MAYBE THIS IS A LITERAL ??? *)
    ELSE   IF  CH = CH_LIT
      THEN   ARI_OPERAND := LITERAL (VAL)

      (* OR IS THIS A QUOTED STRING ??? *)
      ELSE   IF  CH = CH_QTE
        THEN   ARI_OPERAND := ASCIICON (VAL)

        (* IS THIS A NUMBER ?? *)
        ELSE   IF  CH IN ['0'..'9']
          THEN   ARI_OPERAND := SCNNUM (VAL)
  
          (* OR IS THIS A SYMBOL ?? *)
          ELSE   IF  CH IN IDENT_CHARS
            THEN   BEGIN
              SCNR50 (SYMBOL_NAME);
              ARI_OPERAND := ARISYM (SYMBOL_NAME, VAL)
            END
  
            (* OTHERWISE THIS MUST BE AN ERROR... *)
            ELSE   ARI_OPERAND := TRUE;
  
  (* FINALLY BE SURE TO APPLY THE SIGN TO THE NUMBER.. *)
  IF  NEGATIVE  THEN   VAL := (MAXIMUM_NUMBER-VAL+1) MOD (MAXIMUM_NUMBER+1)

END;




(*
      THIS FUNCION SCANS AN OPERATOR FROM THE EXPRESSION. IT EXAMINES
   THE  NEXT  NON-SPACE  CHARACTER;  IF  IT IS A LEGAL OPERATOR, THEN
   ARI_OPERATOR  RETURNS  FALSE, OTHERWISE THERE IS SOME ERROR AND IT
   RETURNS TRUE (AFTER USING CERR TO LOG THE ERROR)...
*)
FUNCTION  ARI_OPERATOR (VAR  OP : CHAR)  : BOOLEAN;
BEGIN

  OP := ILDB;   IF  OP = ' '  THEN   OP := ILDB;
  IF  OP IN ['+', '-']
    THEN   ARI_OPERATOR := FALSE
    ELSE   ARI_OPERATOR := TRUE

END;




(*
      THIS  ROUTINE PUTS ALL THE ABOVE ONES TOGETHER IN ORDER TO SCAN
   THE  COMPLETE  ARITHMETIC  EXPRESSION. NOTE THAT THIS SCANNER WILL
   ONLY  STOP  ON  EOL;  ANY OTHER TERMINATOR IS TREATED AS AN ILEGAL
   OPERATOR.  SCNARI  WILL  TRUE  IF  THERE  WAS  SOME  ERROR  IN THE
   EXPRESSION,  AND FALSE IF THERE WAS NONE. NOTE THAT IN THE CASE OF
   ANY ERROR, A MESSAGE HAS ALWAYS BEEN LOGGED...
*)
FUNCTION   SCNARI;
VAR   OPND : PDP_WORD;   OP : CHAR;   FLAG, DONE : BOOLEAN;
BEGIN

  FLAG := FALSE;   DONE := FALSE;   AC := 0;

  (* THE EXPRESSION ALWAYS STARTS WITH AN OPERAND -- GET IT *)
  IF  ARI_OPERAND (OPND)  THEN   FLAG := TRUE
    ELSE   BEGIN
    AC := OPND;

    (* NOW LOOP THROUGH THE REST OF THE EXPRESSION... *)
    REPEAT

      (* GET AN OPERATOR *)
      IF  ARI_OPERATOR (OP)  THEN   DONE := TRUE

      (* AND GET THE OPERAND *)
        ELSE    IF  ARI_OPERAND (OPND)  THEN   FLAG := TRUE

          (* AND NOW DO THE OPERATION (ADD OR SUBTRACT)... *)
          ELSE  BEGIN  CASE  OP  OF
              '+' : AC := (AC + OPND) MOD (MAXIMUM_NUMBER+1);
              '-' : AC := (AC + (MAXIMUM_NUMBER-OPND+1))  MOD (MAXIMUM_NUMBER+1)
            END   END

      (* AND STOP ON ANY ERROR OR THE END OF THE LINE ... *)
      UNTIL  (FLAG)  OR  (DONE);

    END;

  SCNARI := FLAG

END;



(*
       THIS ROUTINE PERFORMS AN INCLUSIVE OR OF TWO INTEGER VARIABLES,
    AND   RETURNS  AN  INTEGER  RESULT.  I  KNOW  THIS  ALGORITHM  IS
    CRUDE AND SLOW, BUT IT IS PORTABLE.
*)
FUNCTION IOR (A, B : INTEGER) : INTEGER;
VAR K, C: INTEGER;
BEGIN
  IF (A = 0) THEN
    IOR := B
  ELSE IF (B = 0) THEN
    IOR := A
  ELSE BEGIN
    K := 2048;  C := 0;
    WHILE (K > 0) DO BEGIN
      IF (ODD(A DIV K) OR ODD(B DIV K)) THEN C := C + K;
      K := K DIV 2
    END;
    IOR := C
  END
END;








(*
	***** F I R S T   &   S E C O N D   P A S S E S *****

      FOLLOWING  ARE  THE  FIRST AND SECOND PASSES FOR THE ASSEMBLER,
   WITH A FEW MINOR ROUTINES FIRST.

      THESE  ARE  SEPERATE ROUTINES TO PROCESS EACH OF THE PSEUDO-OPS
  (END, ORQ, TITLE, ETC...). ALL OF THOSE ROUTINES MUST BE COMPLETELY
   SELF-CONTAINED,  CALLING  BOTH  LIST AND OBJECT IF THEY NEED TO...
   NOTE THAT  SOME PSEUDO-OPS ARE CALLED ON BOTH PASSES, AND SOME ARE
   ONLY CALLED ON ONE...

      ALSO  INCLUDED  ARE  TWO ROUTINES TO SCAN AND PROCESS TAGS. THE
   FIRST  (TAG_CHECK)  LOOKS  FOR  THE OCCURANCE OF A TAG, AND (IF IT
   FINDSC ONE) SAVES IT AWAY IN TAG_FIELD. THE TAG CANNOT ACTUALLY BE
   DEFINED UNTIL THE REST OF THE LINE HAS BEEN COMPLETELY SCANNED AND
   PROCESSED,  AS  SOME  PSEUDO-OPS  (LIKE EQU) USE THE TAG FIELD FOR
   SPECIAL PURPOSES...

      A SINGLE ROUTINE IS USED BY BOTH PASSES TO IDENTIFY THE TYPE OF
   STATEMENT  BEING  PROCESSED.  THIS  ROUTINE (IDENT) CLASSIFIES THE
   STATEMENT BY RETURNING ONE OF THE ST_??? STATEMENT TYPE CODES...

      AND  FINALLY SEVERAL MINOR ROUTINES ARE USED TO PERFORM SIMLPLE
   SPECIAL  FUNCTIONS, SUCH AS OUTPUTTING THE OBJECT CODE OR PRINTING
   THE NUMBER OF ERRORS DETECTED...
*)




(*
      THIS  ROUTINE  IS  USED  TO  OUTPUT CODE TO THE OBJECT AND LIST
   FILE.  ABOUT  ALL  IT  HAS TO DO IS CALL OBJECT AND LIST TO DO THE
   WORK.  NOTE  THAT  THIS ROUTINE ALSO INCREMENTS THE PC TO THE NEXT
   INSTRUCTION...
*)
PROCEDURE  OUTPUT_CODE;
BEGIN

  IF  PASS_2  THEN
    BEGIN
      IF  PC > LITERAL_BASE-1  THEN   CERR(ER_PAF);
      LIST (GENCODE, LF_LAC);   OBJECT (PC, GENCODE);
    END;
  IF  PC < LITERAL_BASE-1  THEN   PC := (PC+1) MOD (MAXIMUM_NUMBER+1);
  GENCODE := NULL_CODE;

END;




(*
       THIS  ROUTINE  IS CALLED TO EXPAND THE LITERALS INTO THE OUTPUT
    FILE.  NORMALLY,  THIS  IS DONE EVERY TIME THE PROGRAMMER USES THE
    'ORG'  PSEUDO-OP  TO MOVE INTO ANOTHER PAGE. ALL WE REALLY HAVE TO
    DO  HERE  IS  GATER  UP ANY LITERALS WHICH WE HAVE SAVED, AND SEND
    THEM OUT TO THE OBJECT AND LISTING FILES...
*)
PROCEDURE   OUTPUT_LITERALS;
VAR   LOC : INTEGER;
BEGIN

  (* THERE IS NO LITERAL PROCESSING UNDER PASS 1.... *)
  IF  PASS_2  THEN

    (* OUTPUT ALL THE LITERALS THAT WE HAVE... *)
    BEGIN
      LOC := LITERAL_BASE;
      WHILE  (LOC MOD PAGE_SIZE) <> 0  DO
        BEGIN
          PC := LOC;   GENCODE := LITERALS[LOC MOD PAGE_SIZE];
          LIST (GENCODE, LF_LNT);   OBJECT (PC, GENCODE);
          LOC := LOC + 1
        END
    END

END;




(*
      THIS  ROUTINE IS USED TO CHECK FOR THE PRESENCE OF A TAG ON THE
   CURRENT LINE. IF A TAG IS FOUND THEN IT WILL BE SCANNED AND PLACED
   IN  THE  ARRAY TAG_FIELD. NOTE THAT THIS ROUTINE DOES NOT ACTUALLY
   DEFINE  THE  TAG;  THAT  IS LEFT FOR A LATER ROUTINE (BECAUSE SOME
   PSEUDO-OPS  (LIKE  EQU)  MAKE  SPECIAL  USE  OF  THE  TAG FIELD.).
*)
PROCEDURE  TAG_CHECK;
VAR   CH : CHAR;
BEGIN
  TAG_FIELD := BLANK_ID;
  ADJBP(+1);

  (* TRY TO READ A TAG FROM THE LINE... *)
  SCNR50(TAG_FIELD);   CH := ILDB;

  (* IS THIS A EQUATED SYMBOL ???? *)
  IF  CH = '='  THEN   ADJBP(-1)

    (* NO -- SEE IF IT IS REALLY A TAG... *)
    ELSE   IF  CH <> ':'
      THEN  BEGIN   TAG_FIELD := BLANK_ID;   CURSRI := 0   END;

END;




(*
      THIS  ROUTINE IS USED TO DEFINE A TAG THAT HAS BEEN SCANNED. IT
   IS  NORMALLY  CALLED  AFTER  THE  REST  OF  THE STATEMENT HAS BEEN
   PROCESSED.  IF  ANY  TAG HAS BEEN STORED IN THE TAG FIELD, THEN IT
   WILL  BE  ENTERED  INTO  THE  USER  DEFINED  SYMBOL TABLE WITH THE
   CURRENT  PC  AS ITS VALUE. IF THE TAG ALREADY EXISTS IN THE TABLE,
   THEN IT WILL BE FLAGGED AS MULTIPLY DEFINED...
*)
PROCEDURE  TAG_DEFINE;
VAR   NEWSYM : SYMTAB_ENTRY;   INDEX : SYMTAB_INDEX;
BEGIN

  (* WAS THERE A TAG TO BE DEFINED ?? *)
  IF  TAG_FIELD <> BLANK_ID
    THEN   BEGIN

      (*YES -- DOES IT ALREADY EXIST ?? *)
      NEWSYM.SF_MDF := FALSE;
      IF  VALSYM(TAG_FIELD, INDEX)

       (* YES -- THIS SYMBOL IS MULTIPLY DEFINED... *)
       THEN   BEGIN
         SYMTAB[INDEX].SF_MDF := TRUE;
         NEWSYM := SYMTAB[INDEX]
       END;

     (* AND FINALLY WE CAN DEFINE THE NEW SYMBOL... *)
     NEWSYM.NAME := TAG_FIELD;  NEWSYM.VAL := PC;
     NEWSYM.SF_UDF := FALSE;
     NEWSYM.SF_TAG := TRUE;   NEWSYM.SF_EQU := FALSE;
     NEWSYM.SF_OPD := FALSE;
     DEFSYM (NEWSYM)
   END

END;




(*
      THIS  ROUTINE  IS CALLED UNDER PASS TWO TO CHECK OUT ANY TAG ON
   THIS  LINE.  SINCE  THE  TAG  WAS ALREADY DEFINED UNDER PASS 1, WE
   DON'T  NEED TO RE-DEFINE IT, BUT THIS ROUTINE DOES CHECK TO SEE IF
   THERE  ARE ANY ERROR FLAGS SET FOR THAT TAG (I.E. MDF, ETC...) AND
   CALLS CERR IF NECESSARY...
*)
PROCEDURE  TAG_DEF_TWO;
VAR   INDEX : SYMTAB_INDEX;
BEGIN

  (* IS THERE REALLY A TAG THERE ?? *)
  IF  TAG_FIELD <> BLANK_ID
    THEN   BEGIN

      (* LOOK UP THE SYMBOL ( IT MUST ALREADY EXIST... ) *)
      IF VALSYM(TAG_FIELD, INDEX) THEN (* NOTHING *);
    
      (* ARE THERE ANY ERROR FLAGS SET ?? *)
      IF  SYMTAB[INDEX].SF_MDF   THEN   CERR(ER_MDF);
      IF  SYMTAB[INDEX].SF_UDF   THEN   CERR(ER_SYM)

    END

END;




(*
      THIS  ROUTINE IS CALLED TO PROCESS THE END PSEUDO-OP. THIS IS A
   VERY EASY TASK -- ALL WE HAVE TO DO IS SWITCH THE ASSEMBLER TO THE
   NEXT PASS...
*)
PROCEDURE  PO_END;
BEGIN

  (* BE SURE TO LIST THE LINE UNDER PASS 2 ... *)
  IF  PASS_2
    THEN   BEGIN
      OUTPUT_LITERALS;
      LIST (NULL_CODE, LF_LTX);
    END;

  (* AND FINISH THIS PASS... *)
  PASS_1 := FALSE;   PASS_2 := FALSE

END;



(*
      THIS PROCEDURE WILL PROCESS THE OPDEF PSEUDO-OP.  THIS
   PSEUDO-OP MAY BE USED TO DEFINE NEW MRI INSTRUCTIONS IN THE
   ASSEMBLER SYMBOL TABLE..
*)
PROCEDURE PO_OPDEF;
VAR   N : PDP_WORD;   NAME : IDENTIFIER;   NEWSYM : SYMTAB_ENTRY;   INDEX : SYMTAB_INDEX;
BEGIN
  NEWSYM.SF_MDF := FALSE;   NEWSYM.SF_UDF := FALSE;
  NEWSYM.SF_TAG := FALSE;   NEWSYM.SF_EQU := FALSE;
  NEWSYM.SF_OPD := TRUE;
  ADJBP(1);  SCNR50(NAME);
  IF NEXT_CHAR <> '=' THEN CERR(ER_SYN)
    ELSE IF NOT SCNARI(N)
      THEN BEGIN
	NEWSYM.NAME := NAME;   NEWSYM.VAL := N;
        IF VALSYM(NAME, INDEX)
          THEN BEGIN IF PASS_1 THEN BEGIN
	    SYMTAB[INDEX].SF_MDF := TRUE;  CERR(ER_MDF);
          END END
          ELSE DEFSYM (NEWSYM);
        END;
  IF PASS_2 THEN LIST (N, LF_LCD)
END;




(*
      THIS  ROUTINE  IS  USED TO PROCESS THE '=' PSEUDO-OP. '=' TAKES
   THE LABEL IN THE TAG FIELD AND DEFINES IT TO HAVE THE VALUE OF THE
   OPERAND  TO  THE EQU PSEUDO-OP. THE LABEL HAS ALREADY BEEN SCANNED
   AND STORED IN TAG_FIELD. EQU DEFINED SYMBOLS ARE LIKE TAGS IN THAT
   THEY  MAY BE DEFINED ONLY ONE TIME. IF THE USER ATTEMPTS TO DEFINE
   A  SYMBOL  THAT  HAS  ALREADY  BEEN  DEFINED,  THEN THAT SYMBOL IS
   FLAGGED AS MULTIPLY-DEFINED. 
*)
PROCEDURE  PO_EQU;
VAR   N : PDP_WORD;   NEWSYM : SYMTAB_ENTRY;   INDEX : SYMTAB_INDEX;
BEGIN
  NEWSYM.SF_MDF := FALSE;  NEWSYM.SF_UDF := FALSE;

  (* MAKE SURE THAT THERE REALLY IS A TAG THERE... *)
  IF  TAG_FIELD <> BLANK_ID  THEN

  (* GET THE VALUE OF THE ARITHMETIC OPERAND... *)
  IF  NOT(SCNARI(N))
    THEN   BEGIN

      (* MAKE SURE THAT THE SYMBOL IS NOT ALREADY DEFINED... *)
      IF  VALSYM(TAG_FIELD, INDEX)
        THEN   BEGIN
          IF  SYMTAB[INDEX].SF_TAG  THEN   SYMTAB[INDEX].SF_MDF := TRUE;
          NEWSYM := SYMTAB[INDEX]
        END;

      (* AND NOW WE'RE READY TO DEFINE THE NEW SYMBOL... *)
      NEWSYM.NAME := TAG_FIELD;
      NEWSYM.VAL := N;
      NEWSYM.SF_TAG := FALSE;   NEWSYM.SF_EQU := TRUE;
      NEWSYM.SF_OPD := FALSE;
      DEFSYM(NEWSYM)
    END;

  (* REMOVE THE TAG SO THAT TAG_DEFINE WON'T FIND IT... *)
  TAG_FIELD := BLANK_ID

END;




(*
      THIS  ROUTINE IS USED TO HANDLE THE EQU PSEUDO-OP UNDER PASS 2.
   SINCE  THE EQUATED SYMBOL WAS ALREADY DEFINED UNDER PASS 1, ALL WE
   REALLY  NEED  TO DO IS CHECK THE SYNTAX OF THE STATEMENT AND PRINT
   AN ERROR MESSAGE IF ANYTHING ILLEGAL IS FOUND...
*)
PROCEDURE  PO_EQU_TWO;
VAR   INDEX : SYMTAB_INDEX;   N : PDP_WORD;
BEGIN

  (* MAKE SURE THAT THERE IS REALLY A TAG THERE... *)
  IF  TAG_FIELD = BLANK_ID 

    (* NO TAG -- THAT'S AN ERROR.... *)
    THEN  BEGIN   CERR(ER_SYN);   LIST (NULL_CODE, LF_LTX)   END

    (* OTHERWISE CHECK OUT THE EXPRESSION... *)
    ELSE   BEGIN
      IF SCNARI(N) THEN (* NOTHING *);
      IF  LDB <> CH_EOL  THEN   CERR (ER_SYN);
  
      (* AND LOOKUP THE SYMBOL (IT MUST EXIST...) *)
      IF VALSYM(TAG_FIELD, INDEX) THEN (* NOTHING *);
   
      (* ARE THERE ANY ERROR FLAGS SET ?? *)
      IF  SYMTAB[INDEX].SF_MDF  THEN   CERR(ER_MDF);
      IF  SYMTAB[INDEX].SF_UDF  THEN   CERR(ER_SYM);

      (* AND LIST THIS STATEMENT IN ANY CASE... *)
      GENCODE := SYMTAB[INDEX].VAL;
      LIST (GENCODE, LF_LCD);
    END;

  (* REMOVE THE TAG SO THAT TAG_DEF_TWO WON'T FIND IT... *)
  TAG_FIELD := BLANK_ID;

END;




(*
       THIS  PROCEDURE IS  USED TO PROCESS THE BLOCK PSEUDO-OP... THIS
    PSEUDO-OP RESERVES A BLOCK OF WORDS IN MEMORY; EACH WORD IS LOADED
    WITH  THE  VALUE  ZERO...  THE ARGUMENT TO THE PSEUDO-OP GIVES THE
    NUMBER OF DATA WORDS TO RESERVE....
*)
PROCEDURE PO_ZERO;
VAR   N : PDP_WORD;
BEGIN

  (* TRY TO SCAN THE OPERAND... *)
  IF  NOT (SCNARI (N))
    THEN  BEGIN   IF  LDB <> CH_EOL   THEN  CERR(ER_SYN)   END
    ELSE  N := 0;

  (* AND GENERATE ALL THOSE ZEROS... *)
  IF  PASS_2
    THEN  BEGIN
      IF  (PC + N) >= LITERAL_BASE
        THEN   BEGIN   N := 0;   CERR(ER_PAF)   END;
      LIST (NULL_CODE, LF_LAD);
      PC := PC + N
    END
    ELSE   IF  (PC + N)  <  LITERAL_BASE  THEN   PC := PC + N;

END;




(*
       THIS ROUTINE PROCESSES THE ASCIZ PSEUDO-OP. THIS STATEMENT WILL
    GENERATE DATA WORDS CONTAINING THE VALUES OF THE CHARACTERS IN THE
    ARGUMENT STRING...
*)
PROCEDURE PO_ASCIZ;
VAR  CH, MARK : CHAR;
BEGIN

  (* IGNORE ANY BLANKS AFTER THE PSEUDO-OP...*)
  REPEAT   CH := ILDB   UNTIL  CH <> ' ';

  (* REMEMBER WHAT THE QUOTE CHARACTER IS... *)
  IF  CH <> CH_EOL   THEN  
    BEGIN   MARK := CH;   CH := ILDB;   END;

  (* FIRST LIST THE LINE CONTAINING THE TEXT ITSELF... *)
  IF  PASS_2   THEN  LIST (NULL_CODE, LF_LTX);
  SRCLNU := BLANK_LINE;

  (* AND FINALLY GENERATE DATA FOR ALL THE ASCII CHARACTERS... *)
  WHILE  (CH <> MARK)  AND  (CH <> CH_EOL)   DO
    BEGIN
      GENCODE := ORD (CH);
      OUTPUT_CODE;
      CH := ILDB;
    END;

  (* BE SURE TO TERMINATE THE STRING WITH A NULL BYTE... *)
  GENCODE := 0;   OUTPUT_CODE;

END;




(*
       THIS ROUTINE PROCESSES THE SIXBIT PSEUDO-OP. THIS STATEMENT WILL
    GENERATE DATA WORDS CONTAINING THE VALUES OF THE CHARACTERS IN THE
    ARGUMENT STRING...
*)
PROCEDURE PO_SIXBIT;
VAR  CH, MARK : CHAR;   BYTE : BOOLEAN;
BEGIN

  (* IGNORE ANY BLANKS AFTER THE PSEUDO-OP...*)
  REPEAT   CH := ILDB   UNTIL  CH <> ' ';

  (* REMEMBER WHAT THE QUOTE CHARACTER IS... *)
  IF  CH <> CH_EOL   THEN  
    BEGIN   MARK := CH;   CH := ILDB;   END;

  (* FIRST LIST THE LINE CONTAINING THE TEXT ITSELF... *)
  IF  PASS_2   THEN  LIST (NULL_CODE, LF_LTX);
  SRCLNU := BLANK_LINE;   BYTE := TRUE;

  (* AND FINALLY GENERATE DATA FOR ALL THE SIXBIT CHARACTERS... *)
  WHILE  (CH <> MARK)  AND  (CH <> CH_EOL)   DO
    BEGIN
      IF  BYTE
        THEN   GENCODE := (ORD(CH) - ORD(' ')) * 64
        ELSE   BEGIN
                 GENCODE := GENCODE + (ORD(CH) - ORD(' '));
                 OUTPUT_CODE
               END;
      CH := ILDB;   BYTE := NOT BYTE;
    END;

  (* BE SURE TO TERMINATE THE STRING WITH A NULL BYTE... *)
  IF  NOT BYTE  THEN  OUTPUT_CODE;

END;




(*
       THIS  ROUTINE IS CALLED TO PROCESS THE ORG PSEUDO-OP; ORG TAKES
    A SINGLE NUMERIC ARGUMENT WHICH REPRESENTS THE NEW PC...
*)
PROCEDURE PO_ORG;
VAR A : PDP_WORD;
BEGIN
  A := 0;

  (* SCAN THE ADDRESS VALUE *)
  IF NOT SCNARI(A)

    (* MAKE SURE THIS IS ALL THERE IS.. *)
    THEN   IF  LDB <> CH_EOL   THEN  CERR (ER_SYN)

      (* AND FINALLY MAKE THE ASSIGNMENTS *)
    ELSE   IF  (A DIV PAGE_SIZE) <> (PC DIV PAGE_SIZE)
      THEN   BEGIN 
        OUTPUT_LITERALS;
        LITERAL_BASE := (A DIV PAGE_SIZE) * PAGE_SIZE  +  PAGE_SIZE;
        PC := A
      END
      ELSE   PC := A;

  (* IF THIS IS PASS2, THEN BE SURE TO LIST THE LINE OUT... *)
  IF  PASS_2   THEN  LIST (NULL_CODE, LF_LAD);

END;




(*
       THIS ROUTINE IS CALLED TO PROCESS THE TITLE PSEUDO-OP... ALL WE
    HAVE  TO  DO  FOR  THIS  ONE IS TO READ THE REST OF THE CHARACTERS
    FOLLOWING  ON THE LINE (WHICH BECOME THE TITLE STRING), AND (IF WE
    ARE IN PASS2) LIST THE LINE OUT...
*)
PROCEDURE PO_TITLE;
VAR   I : PINTEGER;   CH : CHAR;
BEGIN

  (* SKIP ANY BLANKS AFTER THE PSEUDO-OP... *)
  REPEAT   CH := ILDB;   UNTIL  CH <> ' ';

  (* CLEAR OUT ANY OLD TITLE STRING... *)
  PROGRAM_TITLE := BLANK_LINE;

  (* AND COPY IN THE NEW TITLE... *)
  I := 1;
  WHILE   CH <> CH_EOL   DO
    BEGIN   PROGRAM_TITLE[I] := CH;   CH := ILDB;   I := I + 1   END;

  (* AND FINALLY BE SURE TO LIST THE LINE UNDER PASS 2... *)
  IF  PASS_2  THEN
    BEGIN   FL_PAGE := TRUE;   LIST (NULL_CODE, LF_LTX)   END;

END;




(*
       THIS ROUTINE IS CALLED UNDER PASS 2 TO GENERATE CODE CONTAINING
    DATA.  THIS  MAY  BE  EITHER  THE ARGUMENT TO A DATA PSEUDO-OP, OR
    SIMPLY ANY STATEMENT WHICH LOOKS LIKE DATA (I.E. ANYTHING WHICH IS
    NOT A COMMENT OR PSEUDO-OP). THIS ALSO INCLUDES ANY MACHINE OPCODE
    STATEMENT....
*)
PROCEDURE  DATA;
VAR   N : PDP_WORD;
BEGIN

  (* GET THE OPERAND... *)
  GENCODE := NULL_CODE;
  IF SCNARI(N) THEN (* NOTHING *);
  IF  LDB <> CH_EOL  THEN   CERR (ER_SYN);

  (* AND OUTPUT IT... *)
  GENCODE := N;
  OUTPUT_CODE

END;



(*
      THIS ROUTINE WILL EVALUATE A MRI OPERATION.  IT EXPECTS TO BE
   PASSED THE VALUE OF THE MRI (THE LEFT 3 BITS) AND WILL RETURN THE
   VALUE OF THE MRI EXPRESSION.  IF ALL IS WELL, THEN THE FUNCTION
   WILL RETURN THE VALUE TRUE, OTHERWISE FALSE IS RETURNED...
*)
FUNCTION MRI_EVAL;
VAR  N : PDP_WORD;   ERROR : BOOLEAN;
BEGIN
  ERROR := FALSE;
  IF NEXT_CHAR = CH_IND
    THEN  VAL := IOR(VAL, IBIT)   ELSE  ADJBP(-1);
  IF  SCNARI (N)
    THEN   ERROR := TRUE
    ELSE   IF  (N DIV PAGE_SIZE) = 0
      THEN   VAL := IOR(VAL, N)
      ELSE   IF  (N DIV PAGE_SIZE) <> (PC DIV PAGE_SIZE)
        THEN   BEGIN   CERR(ER_SCT);   ERROR := TRUE   END
        ELSE   VAL := IOR(VAL, IOR(RBIT, (N MOD PAGE_SIZE)));
  MRI_EVAL := ERROR
END;




(*
       THIS  ROUTINE IS CALLED WHENEVER THE ARITHMETIC SCANNER FINDS A
    MACHINE OPCODE. THIS PROCEDURE WILL SCAN THE REST OF THE LINE, AND
    RETURN  THE  VALUE OF THE GENERATED OPCODE. AS A FUNCTION, IT WILL
    RETURN TRUE IF AN ERROR OCCURED, AND FALSE IF THERE WAS NONE...
  
       THERE  ARE 4 BASIC FORMATS OF OPCODES -- THE MRI, OPERATE, IOT,
    AND  THE  CXF.  THE  MRI  TAKES THE NORMAL MEMORY ADDRESS; OPERATE
    INSTRUCTIONS  MAY BE COMBINED; IOT INSTRUCTIONS TAKE NO ARGUMENTS,
    AND  CXF  INSTRUCTIONS  TAKE A SINGLE OCTAL DIGIT AS AN OPERAND...
    ALL   THESE   FORMATS  ARE  MORE  COMPLETELY  DESCRIBED  IN  DEC'S
    DOCUMENTATION FOR THE PDP-8...
*)
FUNCTION   MACHOP;
VAR   N : PDP_WORD;   NAME : IDENTIFIER;   ERROR : BOOLEAN;
BEGIN

  (* FIGURE OUT WHICH TYPE OF OPCODE THIS ONE IS.... *)
  VAL := OPTAB[INDEX].OPCODE;   ERROR := FALSE;
  CASE OPTAB[INDEX].MODE OF

    (*   PROCESS A MEMORY REFERENCE INSTRUCTION... *)
    MRI : ERROR := MRI_EVAL (VAL);

    (* THIS ROUTINE PROCESSES AN OPERATE MICRO-INSTRUCTION *)
    OPR : BEGIN
            WHILE  (ILDB = ' ')  AND  NOT ERROR  DO
              BEGIN
                SCNR50(NAME);
                IF  NOT VALOP (NAME, INDEX)
                  THEN   BEGIN  CERR(ER_UDF);   ERROR := TRUE  END
                  ELSE   IF  OPTAB[INDEX].MODE <> OPR
                    THEN   BEGIN  CERR(ER_MIC);   ERROR := TRUE   END
                    ELSE   VAL := IOR (VAL, OPTAB[INDEX].OPCODE)
              END;
          END;

    (* HERE TO PROCESS A CDF OR CIF INSTRUCTION... *)
    CXF : BEGIN
            IF  SCNARI (N)
              THEN   ERROR := TRUE
              ELSE   IF (N > 7)
                THEN   BEGIN  CERR(ER_RAN);   ERROR := TRUE   END
                ELSE   VAL := VAL + N*8
          END;

    (* HERE TO PROCESS A PIE INSTRUCTION... *)
    PIE : BEGIN
            IF  SCNARI (N)
              THEN   ERROR := TRUE
              ELSE   IF  (N = 0)  OR  (N > 31)
                THEN   BEGIN  CERR(ER_RAN);   ERROR := TRUE   END
                ELSE   VAL := VAL + N*16
           END;

    (* HERE TO PROCESS A PIO INSTRUCTION... *)
    PIO : BEGIN
            IF  SCNARI (N)
              THEN   ERROR := TRUE
              ELSE   IF  (N = 0)  OR  (N > 3)
                THEN   BEGIN  CERR(ER_RAN);   ERROR := TRUE   END
                ELSE   VAL := VAL + N*16
           END;

    (* HERE TO PRECESS AN IOT INSTRUCTON... *)
    IOT : BEGIN   ADJBP(1)   END

  END;

  (* FINISH UP A FEW LOOSE ENDS... *)
  IF  (LDB <> CH_EOL)  AND  (LDB <> CH_LTE)
    THEN   BEGIN  CERR(ER_SYN);   ERROR := TRUE   END;
  ADJBP(-1);   MACHOP := ERROR;

END;




(*
      THIS  ROUTINE  IS CALLED AT THE END OF ASSEMBLY (AFTER ALL ELSE
   IS  DONE)  TO  PRINT  THE  PROGRAM  BREAK AND THE NUMBER OF ERRORS
   DETECTED ON THE USER'S TERMINAL AND IN THE LISTING FILE... THIS IS
   NOT A VERY COMPLICATED FUNCTION...
*)
PROCEDURE  PRINT_BREAK;
VAR   K : PINTEGER;
BEGIN

  (* PRINT A FEW BLANK LINES IN THE LIST FILE...  *)
  CLRLST;   LISTLN;   LISTLN;   LISTLN;

  (* AND SET UP THE PROGRAM BREAK MESSAGE... *)
  PRTSTR (ER_PBR);  IDPB(' ');  PRTOCT(PC, ADDRESS_LEN);
  LISTLN;
  FOR   K := 1  TO  45   DO  WRITE(LSTLIN[K]);   WRITELN;

  (* AND NOW PRINT A MESSAGE GIVING THE NUMBER OF ERRORS DETECTED... *)
  CLRLST;
  IF  ERRORK = 0
    THEN  PRTSTR(ER_NED)
    ELSE  BEGIN   PRTSTR (ER_TED);  IDPB(' ');  PRTDEC(ERRORK);
		  IDPB(' ');   PRTSTR(ER_TE2)   END;
  LISTLN;
  FOR   K := 1  TO  45   DO  WRITE(LSTLIN[K]);   WRITELN;

END;




(*
       THIS  ROUTINE  IS  USED TO IDENTIFY THE CURRENT STATEMENT. THIS
    ROUTINE  THEN  RETURNS AS ITS VALUE THE APPROPRIATE STATEMENT TYPE
    SYMBOL  (ST_???)  FOR  THE  STATEMENT.  THE  CODE ST_UNK IS RETURN
    INSTEAD...
*)
FUNCTION  IDENT : PINTEGER;
VAR   CH : CHAR;   INDEX : POPTAB_INDEX;   FIRST : IDENTIFIER;
BEGIN
 
  (* IS THIS A EQUATE ('=') STATEMENT ??? *)
  CH := ILDB;   IF  CH = ' '   THEN  CH := ILDB;
  IF  CH = '='
    THEN   IDENT := ST_EQU

    (* NO -- HOW ABOUT A PSEUDO-OP ???? *)
    ELSE   IF  CH = CH_PMR
      THEN   BEGIN
        ADJBP(1);   SCNR50(FIRST);
        IF  VALPOP (FIRST, INDEX)
          THEN   IDENT := POPTAB[INDEX].VAL
          ELSE   BEGIN  IDENT := ST_UNK;   CERR(ER_UDF)   END
      END

       (* IF THIS IS THE END OF THE LINE, THEN THIS IS A NULL STATEMENT *)
       ELSE   IF  CH = CH_EOL
         THEN   IDENT := ST_NUL

        (* NOT THAT EITHER, THIS MUST BE A DATA TYPE STATEMENT... *)
        ELSE   BEGIN  ADJBP(-1);   IDENT := ST_MACH   END

END;




(*
      THIS ROUTINE REPRESENTS THE COMPLETE PASS 1 OF THE ASSEMBLER...
*)
PROCEDURE  PASS_ONE;
BEGIN

  (* START OFF THE CODE AT ADDRESS 200 *)
  PC := 128 {200B};   LITERAL_BASE := PC + PAGE_SIZE;

  (* AND REMEMBER THAT THIS IS PASS ONE... *)
  PASS_1 := TRUE;

  REPEAT

    (* LOOK FOR ANOTHER SOURCE LINE -- QUIT IF THERE'S NOT ANY... *)
    IF  NOT(LINE)  THEN   PASS_1 := FALSE

      (* NOW LOOK FOR ANY TAG... *)
      ELSE   BEGIN
        TAG_CHECK;

         (* FINALLY IDENTIFY THE STATEMENT AND PROCESS IT... *)
         CASE  IDENT  OF
           ST_END : PO_END;
           ST_EQU : PO_EQU;
           ST_MACH: BEGIN   TAG_DEFINE;   PC := (PC+1) MOD (MAXIMUM_NUMBER+1)   END;
           ST_DAT : BEGIN   TAG_DEFINE;   PC := (PC+1) MOD (MAXIMUM_NUMBER+1)   END;
           ST_ORG : BEGIN   TAG_DEFINE;   PO_ORG;   END;
           ST_ZER : BEGIN   TAG_DEFINE;   PO_ZERO;   END;
           ST_ASZ : BEGIN   TAG_DEFINE;   PO_ASCIZ;   END;
           ST_SIX : BEGIN   TAG_DEFINE;   PO_SIXBIT;   END;
           ST_TTL : PO_TITLE;
           ST_NUL : TAG_DEFINE;
	   ST_OPD : PO_OPDEF;
	   ST_EJEC: BEGIN   END;
           OTHERWISE BEGIN   END
         END;

      END

  (* AND LOOP UNTIL WE'VE FINISHED THIS PASS... *)
  UNTIL  NOT(PASS_1)

END;




(*
      THIS  ROUTINE  REPRESENTS  THE  COMPLETE  SECOND  PASS  OF  THE
   ASSEMBLER...
*)
PROCEDURE  PASS_TWO;
BEGIN

  (* START OFF THE GENERATED CODE AT ADDRESS 200 *)
  PC := 128 {200B};   LITERAL_BASE := PC + PAGE_SIZE;

  (* AND REMBER THAT WE ARE UNDER PASS 2... *)
  PASS_2 := TRUE;

  REPEAT

    FL_ERR := FALSE;

    (* TRY TO READ THE NEXT SOURCE LINE -- QUIT IF THERE ARE NONE LEFT... *)
    IF  NOT(LINE)  THEN   PASS_2 := FALSE

      (* OTHERWISE TRY TO PROCESS ANY TAG ON THE LINE... *)
      ELSE   BEGIN
        TAG_CHECK;   TAG_DEF_TWO;
 
        (* FINALLY DECODE AND PROCESS THE STATEMENT... *)
        CASE  IDENT  OF
          ST_END : PO_END;
          ST_EQU : PO_EQU_TWO;
          ST_DAT : DATA;
          ST_MACH: DATA;
          ST_ORG : PO_ORG;
          ST_ZER : PO_ZERO;
          ST_ASZ : PO_ASCIZ;
          ST_SIX : PO_SIXBIT;
          ST_NUL : LIST (NULL_CODE, LF_LAD);
          ST_TTL : PO_TITLE;
	  ST_OPD : PO_OPDEF;
	  ST_EJEC: FL_PAGE := TRUE;
          OTHERWISE BEGIN   LIST (NULL_CODE, LF_LTX)    END
        END

      END

  (* AND LOOP UNTIL WE'VE FINISHED THIS PASS... *)
  UNTIL   NOT(PASS_2)

END;








(*
	***** M P L   M A I N   P R O G R A M *****
*)
BEGIN

  (* TELL EVERYONE WHO WE ARE... *)
  WRITELN (TITLE_STRING);

  (* RESET ALL VARIABLES AND TABLES... *)
  START_UP;

  (* MAKE THE FIRST PASS... *)
  RESET(SOURCEFILE);
  WRITELN('PALX - Pass 1');
  PASS_ONE;

  (* AND REWIND THE SOURCE FILE *)
  RESET(SOURCEFILE);  REWRITE(LISTFILE);  REWRITE(OBJECTFILE);

  (* START UP THE OBJECT FILE.... *)
  CHECKSUM := 0;

  (* MAKE THE SECOND PASS... *)
  WRITELN('PALX - Pass 2');
  PASS_TWO;

  (* PRINT THE SYMBOL TABLE AND PROGRAM STATISTICS... *)
  PRINT_BREAK;   SORTSYM;   LSTSYM;

  (* AND FINISH THE OBJECT FILE... *)
  PUNCHSUM;

  (* AND WE'RE ALL DONE -- EASY, RIGHT ??? *)
9999:

END
.
